import matplotlib
matplotlib.rcParams['text.latex.preamble']=[r"\usepackage{amsmath}",r"\renewcommand{\seriesdefault}{\bfdefault}",
r"\usepackage{fixltx2e}"]
params = {'text.usetex' : True,
          'font.size' : 16,
          'font.family' : 'lmodern',
          'text.latex.unicode': True,
          }
matplotlib.rcParams.update(params) 
matplotlib.use("cairo")
import matplotlib.pyplot as plt
import os
import glob
import numpy as np
from Molecule import Molecule
from atomsel import atomsel
import pynamd
import subprocess
bigdict = dict()
for sys in ['monomers', 'dimers']:
	dirlist = glob.glob("../vactest/%s/*/" % sys)
	valuedict = dict()
	for d in dirlist:
		print d
		for subd in ['optimized']:#, 'cgenff']:
			if os.path.exists(d+subd):
				tcllist = glob.glob(d+subd+"/*.tcl")
				for tclfile in tcllist:
					fin = open(tclfile)
					lines = fin.readlines()
					fin.close()
					psfline = lines[1]
					psf = psfline.split()[1]
					num = int(psf[4:-4])
					dcdname = lines[4].split()[2]
					mol = Molecule()
					mol.load(d+subd+"/" + psf)
					mol.load(d+subd+"/run_%d_%s.dcd" % (num, dcdname))
					refsel = atomsel("not water")
					refsel.frame=0
					sel = atomsel("not water")
					sel.frame = mol.numFrames()-1
					rmsd = sel.rmsdQCP(refsel)
					print rmsd
					logfile = tclfile + ".log"
					#log = pynamd.NamdLog(logfile)
					output = subprocess.check_output("grep ^ENERGY: %s" % logfile, shell=True)
					split = output.split("\n")[:-1]
					print output
					data = np.empty((len(split),15), dtype=np.float)
					for i, s in enumerate(split):
						print len(s), s
						data[i] = np.array(s[7:].split(), dtype=np.float)
					print data
					mol.delete()
					if dcdname in valuedict.keys():
						valuedict[dcdname].append(np.hstack([np.array(rmsd), data[0]]))
					else:
						valuedict[dcdname] = [np.hstack([np.array(rmsd), data[0]])]
	bigdict[sys]=valuedict
	for k in bigdict[sys].keys():
		for j, title in zip([2,3,4,6,7,11], ['bond','angle', 'dihed', 'ele', 'vdw', 'total']):
			fig, ax = plt.subplots(1,1)
			datalist = bigdict[sys][k]
			data = np.vstack(datalist)
			ax.scatter(data[:,0], data[:, j])
			fig.savefig("ecorrel%s-%s_%s.png" % (sys, k, title))