from VMD import evaltcl
from Molecule import Molecule
import glob
import os
from atomsel import atomsel
import numpy as np
def mymkdir(s):
	if not os.path.exists(s):
		os.makedirs(s)
def mysymlink(source, dest):
	#print source, dest
	if not os.path.exists(dest):
		os.symlink(source, dest)
cgenffpsflist = glob.glob("cgenffpsfs/*psf")
psflist = glob.glob("psfs/*psf")
jsfiles = glob.glob("js/*.js")
for cgenff in [0]:
	if cgenff:
		textadd = "cgenff-"
		cgendir = "cgenff"
	else:
		textadd = ""
		cgendir = "optimized"
	for jsfile in jsfiles:
		mol = Molecule()
		namecompare = jsfile[3:-3]
		print namecompare
		if cgenff:
			for psfname in cgenffpsflist:
				if namecompare == os.path.basename(psfname)[:-8].lower():
					psf = psfname
		else:
			for psfname in psflist:
				if namecompare == os.path.basename(psfname)[:-4].lower():
					psf = psfname
		print namecompare
		print psf
		#exit()
		mol.load(jsfile)
		mol.load(psf)
		
		mol.save("systems/%s%s.psf" % (textadd,namecompare), filetype='psf')
		#exit()
		sel = atomsel("all")
		dimer = len(np.unique(sel.get("residue"))) > 1
		if dimer:
			testdir = 'dimers'
		else:
			testdir = 'monomers'
		for f in range(mol.numFrames()):
			sel.frame = f
			sel.moveby(-1 * np.array(sel.center()))
			arr = np.array(sel.minmax())
			bdim = 8 + np.amax(arr[1] - arr[0])
			if bdim < 12:
				bdim = 12
			sel.write("pdb", "systems/%s-%d.pdb" % (namecompare, f))
		 	mol.save("systems/%s-%d.pdb" % (namecompare, f), filetype='pdb', first=f, last=f)
		 	mysymlink("../../../../systems/%s%s.psf" % (textadd, namecompare), "vactest/%s/%s/%s/sys-%d.psf" % (testdir, namecompare, cgendir, f))
		 	mysymlink("../../../../systems/%s-%s-%d.pdb" % (textadd, namecompare, f), "vactest/%s/%s/%s/sys-%d.pdb" % (testdir, namecompare, cgendir, f))
			evaltcl("package require solvate; solvate systems/%s.psf systems/%s-%d.pdb -minmax [list [list -%f -%f -%f] [list %f %f %f]] -o systems/%ssolvated-%s-%d" % (namecompare, namecompare, f, bdim, bdim, bdim, bdim, bdim, bdim, textadd, namecompare, f))
			evaltcl("mol load psf systems/%ssolvated-%s-%d.psf pdb systems/%ssolvated-%s-%d.pdb ; set allsel [atomselect top \"all\"] ; $allsel set beta 0 ; [atomselect top \"not water\"] set beta 1 ; $allsel writepdb systems/%ssolvated-%s-%d.pdb" % (textadd, namecompare, f, textadd, namecompare, f, textadd, namecompare, f))
		 	mymkdir("tests/%s/%s" % (testdir, namecompare))
		 	mymkdir("tests/%s/%s/%s" % (testdir, namecompare, cgendir))
		 	mysymlink("../../../../systems/%ssolvated-%s-%d.psf" % (textadd, namecompare, f), "tests/%s/%s/%s/sys-%d.psf" % (testdir, namecompare, cgendir, f))
		 	mysymlink("../../../../systems/%ssolvated-%s-%d.pdb" % (textadd, namecompare, f), "tests/%s/%s/%s/sys-%d.pdb" % (testdir, namecompare, cgendir, f))
		 	#mysymlink("../../../../systems/%s%s.psf" % (textadd, namecompare), "tests/%s/%s/%s/sys-%d.psf" % (testdir, namecompare, cgendir, f))
		 	#mysymlink("../../../../systems/%s-%d.pdb" % (namecompare, f), "tests/%s/%s/%s/sys-%d.pdb" % (testdir, namecompare, cgendir, f))
exit()