import glob
import subprocess
import os
def mymkdir(s):
	if not os.path.exists(s):
		os.makedirs(s)
def mysymlink(source, dest):
	#print source, dest
	if not os.path.exists(dest):
		os.symlink(source, dest)
sourcetemplate = '''
structure %s
set coordfile %s
coordinates $coordfile
set prmname %s
set prmfile %s
set extraprm %s
set edgelength %f
set runnumber %d
'''
paramsets = glob.glob("parameters/lignin*prm")
jsfiles = glob.glob("js/*.js")
for superd in ['monomers', 'dimers']:
	dirs = glob.glob("vactest/%s/*/" % superd)
	print dirs
	for d in dirs:
		for subd in ['optimized']:
			#print subd
			psflist = glob.glob("%s%s/*psf" % (d, subd))
			print psflist
			counter = 0
			for psf in psflist:
				print psf
				runnum = int(psf.split('-')[1][:-4])
				edgelength = float(subprocess.check_output("grep CRYST %s | awk '{print $2}'" % (psf[:-4] + ".pdb"), shell=True))
				basename = os.path.basename(psf)
				print basename
				for p in paramsets:
					p = p[11:]
					pname = p[6:-4]
					print pname
					if 'solution' in pname:
						pname = pname[:-8]
					source = sourcetemplate % (basename, basename[:-4] + ".pdb", pname, "../../../../parameters/" + p, "../../../../parameters/extraterms-" + p, edgelength, runnum)

					fout = open("%s%s/loadstuff-%02d.tcl" % (d, subd, counter), "w")
					fout.write(source)
					fout.close()
					#mysymlink("../../../eq.namd", "%s%s/eq.namd" % (d,subd))
					#subprocess.call("cd %s%s; namd2 +p8 eq.namd | tee %s.log"%(d, subd, pname), shell=True)
					counter += 1
scripttemplate = '''#!/bin/bash
#PBS -d %s
#PBS -j oe
#PBS -m ae
#PBS -q batch
#PBS -N %s
#PBS -l nodes=1:ppn=8

%s
'''
os.chdir("vactest")
for superd in ['monomers', 'dimers']:
	os.chdir(superd)
	dirs = glob.glob("*/")
	print dirs
	for d in dirs:
		os.chdir(d)
		print d
		for subd in ['optimized']:
			if not os.path.exists(subd):
				continue
			os.chdir(subd)
			mysymlink("../../../eq.namd", "eq.namd")
			tcllist = glob.glob("*.tcl")
			string = ""
			for tclfile in tcllist:
				string += "ln -s %s loadstuff.tcl\n" % tclfile
				string += "~/NAMD_Git-2017-09-19_Linux-x86_64-multicore/namd2 +p8 eq.namd > %s.log\n" % tclfile
				string += "rm loadstuff.tcl\n"
			script = scripttemplate % (os.getcwd(), superd+d+subd, string)
			fout = open("run.tmp", "w")
			fout.write(script)
			fout.close()
			os.system("qsub run.tmp")
			os.chdir("..")
		os.chdir("..")
	os.chdir("..")
exit()
	
