from Molecule import *
from atomsel import *
import numpy as np
import vmdnumpy as vnp
import os
import glob
optfileheader = '''-#- CacheSize=163840
-M- 16GB
-#- MaxDisk=128GB
-P- 16

# HF/6-31G* Opt=Tight SCF=Tight Geom=PrintInputOrient

 Title

%d 1
'''
def mymkdir(s):
	if not os.path.exists(s):
		os.makedirs(s)
def mysymlink(source, dest):
	#print source, dest
	if not os.path.exists(dest):
		os.symlink(source, dest)
#for linkage in ['BO4', '55', '4O5', 'AO4', 'B5', 'B1', 'BB', 'BDO', 'GOG']:
namelist = ['lihe', 'bet1', 'bet2', 'ppgys', 'gpgys', 'cpgys', 'spgys']
for name in namelist:
	os.chdir("geomopt")
	mymkdir(name)
	os.chdir("..")
	m = Molecule()
	m.load(name + ".psf")
	m.load(name + ".pdb")
	sel = atomsel("all")
	names = sel.get("name")
	R = vnp.timestep(m, 0)
	charge = 0
	fout = open("geomopt/" + name + "/" + name + ".gau", "w")
	fout.write(optfileheader % charge)
	for i in range(len(sel)):
		fout.write("%s%d %.7f %.7f %.7f\n" % (names[i][0], i+1, R[i][0], R[i][1], R[i][2]))
	fout.write("\n")
	fout.close()
	m.delete()
exit()
for linkage in ['AOG']:
	#These linkages enforce some combinatorial constraints. For instance, BDO is only possible using C-lignin
	reslist1 = ['PHP'] # Shrinks the space considerably, since usually the parts that are different will be far away anyway.
	reslist2 = ['PHP', 'GUAI', 'SYR', 'CAT']
	if linkage == 'AOG':
		reslist1 = reslist2
		reslist2 = ['PHP']
	if linkage == 'GOG':
		reslist1 = ['PCA']
	if linkage == 'BDO':
		reslist2 = ['CAT']
	if linkage in ['4O5', 'B5', '55']:
		reslist2 = ['PHP', 'GUAI', 'CAT']
		if linkage == '55':
			reslist1 = ['PHP', 'GUAI', 'CAT']
		elif linkage == '4O5':
			reslist1 = ['PHP', 'GUAI', 'CAT']
	if linkage == 'BB':
		reslist2 = ['PHP']
	#This is H, G, S, and C-lignin.
	for resname in reslist1:
		for resname2 in reslist2:
			name = (resname[0] + linkage + resname2[0]).lower()
			namelist = glob.glob("%s*.pdb" % name)
			maxlength = max(len(s) for s in namelist)
			newnamelist = [s for s in namelist if len(s) == maxlength]
			for n in newnamelist:
				os.chdir("geomopt")
				mymkdir(n[:-4])
				os.chdir("..")
				m = Molecule()
				m.load(name + ".psf")
				m.load(n)
				sel = atomsel("all")
				names = sel.get("name")
				R = vnp.timestep(m, 0)
				charge = int(np.sum(sel.get("charge")))
				fout = open("geomopt/" + n[:-4] + "/" + n[:-4] + ".gau", "w")
				fout.write(optfileheader % charge)
				for i in range(len(sel)):
					fout.write("%s%d %.7f %.7f %.7f\n" % (names[i][0], i+1, R[i][0], R[i][1], R[i][2]))
				fout.write("\n")
				fout.close()
				m.delete()
exit()
