package require forcefieldtoolkit
package require topotools
proc ::ForceFieldToolKit::gui::consoleMessage { text } {
	puts $text
}
set halthere 0
#foreach dir [glob -directory geomopt -types d -tails *] {
foreach dir [list caogp gaogp paogp saogp] {
	#set basename [string trim $dir [list r s]]
	set basename $dir
	if {! [file exists $basename.psf]} {
		set basename [format "%ss" $basename]
		set halthere 1
	}
		#mol new ../optimization/chargeoptimization/test/psfs/$basename.psf
		mol new $basename.psf
		mol addfile $dir-optimized.pdb
		topo guessatom element mass
		set sel [atomselect top "all"]
		set numbonds [$sel get numbonds]
		set elements [$sel get element]
		set names [$sel get name]
		#set q [expr {int([vecsum [$sel get charge]])}]
		set q 0
		::ForceFieldToolKit::GenDihScan::init
		#Create diheddata. Each row is a list with three elements: a list of the atom indcies, the scan maximum, and the scan increment.
		set diheddata [list ]
		foreach dihedral [topo getdihedrallist -sel "noh and (withinbonds 3 of residue 0) and (withinbonds 3 of residue 1)"] {
			set idxs [lrange $dihedral 1 end]
			puts $idxs
			set range 180
			set increment 15
			set idx1 [lindex $idxs 1]
			set idx2 [lindex $idxs 2]
			set el1 [lindex $elements $idx1]
			set el2 [lindex $elements $idx2]
			if { [lindex $numbonds $idx1] == 3 && [lindex $numbonds $idx2] == 3 && ($el1 == "C" || $el1 == "N") && ($el2 == "C" || $el2 == "N")} {
				set range 30
				set increment 5
			}
			#Check to see if the pair is already in the list
			set newdihedral 1
			foreach dhd $diheddata {
				set mididxs [lrange [lindex $dhd 0] 1 2]
				if {[lsearch $mididxs $idx1] >= 0 && [lsearch $mididxs $idx2] >= 0} {
					set newdihedral 0
				}
			}
			if {$newdihedral} {
				lappend diheddata [list $idxs $range $increment]
			}
		}
		# foreach dihedral [topo getdihedrallist] {
		# 	set idxs [lrange $dihedral 1 end]
		# 	puts $idxs
		# 	set range 180
		# 	set increment 15
			
		# 	set idx1 [lindex $idxs 1]
		# 	set idx2 [lindex $idxs 2]
		# 	set n1 [lindex $names $idx1]
		# 	set n2 [lindex $names $idx2]
		# 	set el1 [lindex $elements $idx1]
		# 	set el2 [lindex $elements $idx2]
		# 	if { [lindex $numbonds $idx1] == 3 && [lindex $numbonds $idx2] == 3 && [lsearch [list C1 C2 C3 C4 C5 C6] $n1] != -1 && [lsearch [list C1 C2 C3 C4 C5 C6] $n2]} {
		# 		set range 30
		# 		set increment 5
		# 	}
		# 	#Check to see if the pair is already in the list
		# 	set newdihedral 1
		# 	foreach dhd $diheddata {
		# 		set mididxs [lrange [lindex $dhd 0] 1 2]
		# 		if {[lsearch $mididxs $idx1] >= 0 && [lsearch $mididxs $idx2] >= 0} {
		# 			set newdihedral 0
		# 		}
		# 	}
		# 	if {$newdihedral} {
		# 		lappend diheddata [list $idxs $range $increment]
		# 	}
		# }
		puts $diheddata
		#exit
		file mkdir dihedscan/$dir
		set ::ForceFieldToolKit::GenBonded::qmProc 1
		set ::ForceFieldToolKit::GenBonded::qmMem 1
		#set ::ForceFieldToolKit::GenDihScan::psf ../optimization/chargeoptimization/test/psfs/$basename.psf
		set ::ForceFieldToolKit::GenDihScan::psf $dir.psf
		set ::ForceFieldToolKit::GenDihScan::pdb $dir-optimized.pdb
		set ::ForceFieldToolKit::GenDihScan::qmRoute "# opt=modredundant MP2/6-31g(d) Geom=PrintInputOrient"
		set ::ForceFieldToolKit::GenDihScan::qmCharge $q
		set ::ForceFieldToolKit::GenDihScan::qmMult 1
		set ::ForceFieldToolKit::GenDihScan::outPath dihedscan/$dir
		set ::ForceFieldToolKit::GenDihScan::basename $basename
		set ::ForceFieldToolKit::GenDihScan::dihData $diheddata
		::ForceFieldToolKit::GenDihScan::buildGaussianFiles
}
exit