import os
from Molecule import Molecule
from VMD import evaltcl
import vmdnumpy as vnp
import numpy as np
from atomsel import *
#for linkage in ['BO4', '55', '4O5', 'AO4', 'B5', 'B1', 'BB', 'BDO', 'GOG']:
for linkage in ['AOA', 'GOA']:

	#These linkages enforce some combinatorial constraints. For instance, BDO is only possible using C-lignin
	reslist1 = ['PHP'] # Shrinks the space considerably, since usually the parts that are different will be far away anyway.
	reslist2 = ['PHP', 'GUAI', 'SYR', 'CAT']
	if linkage == 'GOG':
		reslist1 = ['PCA']
	if linkage == 'BDO':
		reslist2 = ['CAT']
	if linkage in ['4O5', 'B5', '55']:
		reslist2 = ['PHP', 'GUAI', 'CAT']
		if linkage == '55':
			reslist1 = ['PHP', 'GUAI', 'CAT']
		elif linkage == '4O5':
			reslist1 = ['PHP', 'GUAI', 'CAT']
	if linkage == 'BB':
		reslist2 = ['PHP']
	if linkage in ['AOG', 'AOA']:
		if linkage == ['AOG']:
			reslist1 = reslist2
		reslist2 = ['PHP']
		#bonuslinkage = "patch LCAC ligm 1"
		bonuslinkage = "patch LCAC LIGM:1"
	else:
		bonuslinkage = ""
	if linkage in ['GOA']:
		reslist1 = ['PCA']
		reslist2 = ['PHP']
	#This is H, G, S, and C-lignin.
	for resname in reslist1:
		for resname2 in reslist2:
			name = resname[0] + linkage + resname2[0]
			charmmscript = '''ioformat extended
read rtf card name parameters/lignin.top
read para card name parameters/lignin.prm

read sequ card
**
*
2
%s %s

generate ligm first none last none angle dihe setup
%s
patch %s ligm 1 ligm 2
AUTOGENERATE ANGLES DIHEDRAL
write psf card name dimers/%s.psf
ic generate
ic param
ic seed 1 C1 1 C2 1 C3
ic build
mini sd nstep 5000
write coor pdb name dimers/%s.pdb
stop
''' % (resname.lower(), resname2.lower(), bonuslinkage, linkage.lower(), name.lower(), name.lower())
			fout = open("dimers/%s.inp" % name.lower(), "w")
			fout.write(charmmscript)
			fout.close()
			#os.system("charmm < dimers/%s.inp > dimers/%s.log" % (name.lower(), name.lower()))
			psfgenscript = '''package require psfgen
topology parameters/lignin.top
resetpsf
segment LIGM {
	residue 1 %s
	residue 2 %s
}
%s
patch %s LIGM:1 LIGM:2
coordpdb dimers/p%sp-optimized.pdb
regenerate angles dihedrals
guesscoord
writepsf dimers/%s.psf
writepdb dimers/%s.pdb
''' % (resname, resname2, bonuslinkage, linkage, linkage.lower()[:-1]+'g', name.lower(), name.lower())
			evaltcl(psfgenscript)
			mol = Molecule()
			mol.load("dimers/%s.psf" % name.lower())
			mol.load("dimers/%s.pdb" % name.lower())
			sel = atomsel("all")
			sel.set("name", sel.get("element"))
			sel.set("type", sel.get("element"))
			sel.write("mol2", name + ".mol2")
			R = vnp.timestep(int(mol), 0)
			stopcondition = False
			print name.lower()
			for i in range(len(R)):
				for j in range(i+1, len(R)):
					if np.linalg.norm(R[i]-R[j]) < 0.1:
						print "Atoms %d and %d are too close" % (i, j)
						stopcondition = True
			if stopcondition:
				exit()
			mol.delete()