import os
from Molecule import Molecule
import vmdnumpy as vnp
import numpy as np
#for linkage in ['BO4', '55', '4O5', 'AO4', 'B5', 'B1', 'BB', 'BDO', 'GOG']:
linkage1 = '55'
linkage2 = '4O5'
reslist = ['PHP', 'GUAI', 'CAT']
#This is H, G, S, and C-lignin.
for resname in reslist:
	for resname2 in reslist:
		name = resname[0] + "tri4o5" + resname2[0]
		charmmscript = '''ioformat extended
read rtf card name parameters/lignin.top
read para card name parameters/lignin.prm

read sequ card
**
*
3
%s %s php

generate ligm first none last none angle dihe setup
patch 4o5 ligm 1 ligm 2
patch 55 ligm 1 ligm 3

write psf card name trimers/%s.psf
ic generate
ic param
ic seed 1 C1 1 C2 1 C3
ic build
mini sd nstep 5000
write coor pdb name trimers/%s.pdb
stop
''' % (resname.lower(), resname2.lower(), name.lower(), name.lower())
		fout = open("trimers/%s.inp" % name.lower(), "w")
		fout.write(charmmscript)
		fout.close()
		os.system("charmm < trimers/%s.inp > trimers/%s.log" % (name.lower(), name.lower()))
		mol = Molecule()
		mol.load("trimers/%s.psf" % name.lower())
		mol.load("trimers/%s.pdb" % name.lower())
		R = vnp.timestep(int(mol), 0)
		stopcondition = False
		print name.lower()
		for i in range(len(R)):
			for j in range(i+1, len(R)):
				if np.linalg.norm(R[i]-R[j]) < 0.1:
					print "Atoms %d and %d are too close" % (i, j)
					stopcondition = True
		if stopcondition:
			exit()
		mol.delete()