from Molecule import *
from atomsel import *
import numpy as np
import vmdnumpy as vnp
import os
import topology
import measure
from VMD import evaltcl
optfileheader = '''-#- CacheSize=163840
-M- 16GB
-#- MaxDisk=128GB
-P- 16

# opt=modredundant MP2/6-31g(d) Geom=PrintInputOrient

%s Scan at MP2/6-31G*

%d 1
'''
def mymkdir(s):
	if not os.path.exists(s):
		os.makedirs(s)
def mysymlink(source, dest):
	#print source, dest
	if not os.path.exists(dest):
		os.symlink(source, dest)
for residue in ['cat', 'php', 'syr', 'guai']:
	#for c, combination in enumerate(['rr','ss', 'rs', 'sr']):
	for c, combination in enumerate(['lcac', 'lcap', 'lcal', 'lch', 'dbac', 'dbap', 'dbal']):
		os.chdir("bondopt")
		mymkdir(residue+combination)
		os.chdir("..")
		m = Molecule()
		m.load(residue + combination + ".psf")
		m.load(residue + combination + "-optimized.pdb")
		evaltcl("package require topotools; topo guessatom element mass;")
		sel = atomsel("all")
		exclude = atomsel("name C1 C2 C3 C4 C5 C6 O4 O5 C10 O10 C11 O3").get("index")
		names = sel.get("name")
		charge = int(round(np.sum(sel.get("charge"))))
		R = vnp.timestep(m, 0)
		for counter, b in enumerate(topology.bonds()):
			if c and (b[0] in exclude or b[1] in exclude):
				continue
			for j, scantext in enumerate(["pos", "neg"]):
				titletext = "B %d %d %s Bond" % (b[0]+1,b[1]+1, scantext)
				fout = open("bondopt/" + residue + combination + "/" + residue + combination + "bond" + str(counter) + scantext + ".gau", "w")
				fout.write(optfileheader % (titletext, charge))				
				for i in range(len(sel)):
					fout.write("%s%d %f %f %f\n" % (names[i][0], i+1, R[i][0], R[i][1], R[i][2]))
				fout.write("\nB %d %d S 2 %f\n\n" % (b[0]+1,b[1]+1,0.05 - j * 0.1))
				fout.close()
		for counter, a in enumerate(topology.angles()):
			if c and (a[1] in exclude):
				continue
			for j, scantext in enumerate(["pos", "neg"]):
				titletext = "A %d %d %d %s Angle" % (a[0]+1,a[1]+1, a[2]+1, scantext)
				fout = open("bondopt/" + residue + combination + "/" + residue + combination + "angle" + str(counter) + scantext + ".gau", "w")
				fout.write(optfileheader % (titletext, charge))				
				for i in range(len(sel)):
					fout.write("%s%d %f %f %f\n" % (names[i][0], i+1, R[i][0], R[i][1], R[i][2]))
				fout.write("\nA %d %d %d S 2 %f\n\n" % (a[0]+1,a[1]+1,a[2]+1,5 - 10*j))
				fout.close()
		m.delete()
exit()
for residue in ['cat', 'php', 'syr', 'guai', 'pca', 'feru']:
	combination = 'dbbl'
	os.chdir("bondopt")
	mymkdir(residue+combination)
	os.chdir("..")
	m = Molecule()
	m.load(residue + combination + ".psf")
	m.load(residue + combination + "-optimized.pdb")
	evaltcl("package require topotools; topo guessatom element mass;")
	sel = atomsel("all")
	names = sel.get("name")
	charge = int(round(np.sum(sel.get("charge"))))
	exclude = atomsel("name C1 C2 C3 C4 C5 C6 O4 O5 C10 O10 C11 O3").get("index")
	R = vnp.timestep(m, 0)
	for counter, b in enumerate(topology.bonds()):
		if b[0] in exclude or b[1] in exclude:
			continue
		for j, scantext in enumerate(["pos", "neg"]):
			titletext = "B %d %d %s Bond" % (b[0]+1,b[1]+1, scantext)
			fout = open("bondopt/" + residue + combination + "/" + residue + combination + "bond" + str(counter) + scantext + ".gau", "w")
			fout.write(optfileheader % (titletext, charge))				
			for i in range(len(sel)):
				fout.write("%s%d %f %f %f\n" % (names[i][0], i+1, R[i][0], R[i][1], R[i][2]))
			fout.write("\nB %d %d S 4 %f\n\n" % (b[0]+1,b[1]+1,0.05 - j * 0.1))
			fout.close()
	for counter, a in enumerate(topology.angles()):
		if a[1] in exclude:
			continue
		for j, scantext in enumerate(["pos", "neg"]):
			titletext = "A %d %d %d %s Angle" % (a[0]+1,a[1]+1, a[2]+1, scantext)
			fout = open("bondopt/" + residue + combination + "/" + residue + combination + "angle" + str(counter) + scantext + ".gau", "w")
			fout.write(optfileheader % (titletext, charge))				
			for i in range(len(sel)):
				fout.write("%s%d %f %f %f\n" % (names[i][0], i+1, R[i][0], R[i][1], R[i][2]))
			fout.write("\nA %d %d %d S 4 %f\n\n" % (a[0]+1,a[1]+1,a[2]+1,5 - 10*j))
			fout.close()
	m.delete()
exit()