import matplotlib
matplotlib.rcParams['text.latex.preamble']=[r"\usepackage{amsmath}",r"\renewcommand{\seriesdefault}{\bfdefault}",
r"\usepackage{fixltx2e}"]
params = {'text.usetex' : True,
          'font.size' : 16,
          'font.family' : 'lmodern',
          'text.latex.unicode': True,
          }
matplotlib.rcParams.update(params) 
import numpy as np
import matplotlib.cm as cm
import matplotlib.pyplot as plt
from matplotlib.colors import LogNorm
parametersets = [np.load('parameters.npy')]
otherlabels = ['cgenff']
fixdelta = False
upper = False
upper2 = False
idxs = [0]
i=0
for prefix in ['loose', 'tight', 'tight', 'tight', 'tight']:
	for j, midfix in enumerate(['noforce','', 'strongforce', 'reallystrongforce']):
		if prefix == 'tight' and fixdelta and upper:
			midfix += 'fixdeltaupper'
			if upper2:
				midfix += "2"
		if prefix == 'tight' and fixdelta and not upper:
			midfix += 'fixdelta'
		print prefix, midfix, i
		parametersets.append(np.load("pythonlibrary/%sbounds%ssolution.npy" % (prefix, midfix)))
		i += 1
		if j <2:
			idxs.append(i)
			otherlabels.append(prefix+midfix)
	if prefix == 'tight' and fixdelta and upper:
		upper2=True
	if prefix == 'tight' and fixdelta:
		upper=True
	if prefix == 'tight':
		fixdelta= True
print len(parametersets), len(otherlabels)
print idxs
print i
#exit()
idxs = idxs[:-2]
#otherlabels = otherlabels[:-2]
otherlabels = ['CGenFF', 'Free, v=0', "Free, v=0.02", "Set A, v=0", "Set A, v=0.02", "Set B, v=0", "Set B, v=0.02", "Set C, v=0", "Set C, v=0.02"]
otheridxs = idxs
#exit()
fig, axes = plt.subplots(4,2, sharex=True, sharey=True, figsize=(10,20))
fig.subplots_adjust(wspace=0, hspace=0, left=0.15, right=0.85, top=0.98)
cmap = cm.get_cmap('viridis')
params = np.vstack(parametersets)
#print parametersets
#print np.load("numbers.npy")
numframes, nummols, numbondtypes, numangletypes, numdihedraltypes = np.load("numbers.npy")
params = params[:,nummols:]
#print params

n1ks = params[:,(2*numbondtypes)+(4*numangletypes)::5]
n2ks = params[:,1+(2*numbondtypes)+(4*numangletypes)::5]
n3ks = params[:,2+(2*numbondtypes)+(4*numangletypes)::5]
n4ks = params[:,3+(2*numbondtypes)+(4*numangletypes)::5]
n6ks = params[:,4+(2*numbondtypes)+(4*numangletypes)::5]
#I want CGenFF (0th index) and tightfixdelta (9th index)
fig, axes = plt.subplots(3,1, sharex=True)
colors = ['k', 'r', 'g', 'skyblue', 'b']
#print labels[0], labels[9]
ax = axes[0]
labels=[1,2,3,4,6]
for i in range(5):
	idxs = np.nonzero(params[0,i+(2*numbondtypes)+(4*numangletypes)::5])[0]
	diffs = ((params[9,i+(2*numbondtypes)+(4*numangletypes)::5]-params[0,i+(2*numbondtypes)+(4*numangletypes)::5]))[idxs]
	H, edges = np.histogram(diffs, bins=20)
	y = np.cumsum(H) / float(np.sum(H))
	ax.plot(0.5 * (edges[1:]+edges[:-1]), y, color=colors[i], label="n=%d"%labels[i])
ax.legend()
ax = axes[1]
for i in range(5):
	idxs = np.nonzero(params[0,i+(2*numbondtypes)+(4*numangletypes)::5])[0]
	diffs = ((params[13,i+(2*numbondtypes)+(4*numangletypes)::5]-params[0,i+(2*numbondtypes)+(4*numangletypes)::5]))[idxs]
	H, edges = np.histogram(diffs, bins=20)
	y = np.cumsum(H) / float(np.sum(H))
	ax.plot(0.5 * (edges[1:]+edges[:-1]), y, color=colors[i])
ax = axes[2]
for i in range(5):
	idxs = np.nonzero(params[0,i+(2*numbondtypes)+(4*numangletypes)::5])[0]
	diffs = ((params[17,i+(2*numbondtypes)+(4*numangletypes)::5]-params[0,i+(2*numbondtypes)+(4*numangletypes)::5]))[idxs]
	H, edges = np.histogram(diffs, bins=20)
	y = np.cumsum(H) / float(np.sum(H))
	ax.plot(0.5 * (edges[1:]+edges[:-1]), y, color=colors[i])
ax.set_xlabel("Difference in dihedral k-value (kcal/mol)")

fig.savefig("differencedistribution.png")
#exit()
labels=otherlabels
fig, axes = plt.subplots(4,2, sharex=True, sharey=True, figsize=(8,12))
fig.subplots_adjust(wspace=0, hspace=0, left=0.15, right=0.8, top=0.98)
idxs=otheridxs
print idxs
print params.shape
bondks = params[idxs,:2*numbondtypes:2]
bondds = params[idxs,1:2*numbondtypes:2]
print bondks.shape
bondkmatrix = np.corrcoef(bondks)
ax = axes[0][0]
cax = ax.imshow(bondkmatrix, interpolation="nearest", cmap=cmap, norm=LogNorm(vmin=0.5, vmax=1))

print bondkmatrix
bonddmatrix = np.corrcoef(bondds)
ax = axes[0][1]
cax = ax.imshow(bonddmatrix, interpolation="nearest", cmap=cmap, norm=LogNorm(vmin=0.5, vmax=1))
print bonddmatrix

angleks = params[idxs,(2*numbondtypes):(2*numbondtypes)+(4*numangletypes):4]
anglets = params[idxs,1+(2*numbondtypes):(2*numbondtypes)+(4*numangletypes):4]
ubks = params[idxs,2+(2*numbondtypes):(2*numbondtypes)+(4*numangletypes):4]
ubts = params[idxs,3+(2*numbondtypes):(2*numbondtypes)+(4*numangletypes):4]
anglekmatrix = np.corrcoef(angleks)
ax = axes[1][0]
cax = ax.imshow(anglekmatrix, interpolation="nearest", cmap=cmap, norm=LogNorm(vmin=0.5, vmax=1))
print anglekmatrix
angletmatrix = np.corrcoef(anglets)
ax = axes[1][1]
cax = ax.imshow(angletmatrix, interpolation="nearest", cmap=cmap, norm=LogNorm(vmin=0.5, vmax=1))
print angletmatrix
ubkmatrix = np.corrcoef(ubks)
ax = axes[2][0]
cax = ax.imshow(ubkmatrix, interpolation="nearest", cmap=cmap, norm=LogNorm(vmin=0.5, vmax=1))
print ubkmatrix
ubtmatrix = np.corrcoef(ubts)
ax = axes[2][1]
cax = ax.imshow(ubtmatrix, interpolation="nearest", cmap=cmap, norm=LogNorm(vmin=0.5, vmax=1))
print ubtmatrix

dihedralks = params[idxs,(2*numbondtypes)+(4*numangletypes):]
dihedralmatrices = np.corrcoef(dihedralks)
ax = axes[3][0]
cax = ax.imshow(dihedralmatrices, interpolation="nearest", cmap=cmap, norm=LogNorm(vmin=0.5, vmax=1))
print dihedralmatrices
n1ks = params[idxs,(2*numbondtypes)+(4*numangletypes)::5]
dihedralmatrices = np.corrcoef(n1ks)
print dihedralmatrices
n2ks = params[idxs,1+(2*numbondtypes)+(4*numangletypes)::5]
dihedralmatrices = np.corrcoef(n2ks)
print dihedralmatrices
n3ks = params[idxs,2+(2*numbondtypes)+(4*numangletypes)::5]
dihedralmatrices = np.corrcoef(n3ks)
print dihedralmatrices
n4ks = params[idxs,3+(2*numbondtypes)+(4*numangletypes)::5]
dihedralmatrices = np.corrcoef(n4ks)
print dihedralmatrices
n6ks = params[idxs,4+(2*numbondtypes)+(4*numangletypes)::5]
dihedralmatrices = np.corrcoef(n6ks)
print dihedralmatrices
for i in range(4):
	for j in range(2):
		ax = axes[i][j]
		ax.grid(True)
		ax.set_xticks(np.arange(9))
		ax.set_yticks(np.arange(9))
		ax.set_xticklabels(labels, rotation=45, ha='right', fontsize=14)
		ax.set_yticklabels(labels, rotation=45, va='top', fontsize=14)
		ax.set_adjustable("box-forced")
		#ax.autoscale(True)
axes[0][0].text(0.5, 1.02, "Force Constants", transform=axes[0][0].transAxes, ha='center')
axes[0][1].text(0.5, 1.02, "Centers", transform=axes[0][1].transAxes, ha='center')
axes[0][1].text(1.02, 0.5, "Bonds", transform=axes[0][1].transAxes, va='center', rotation='vertical')
axes[1][1].text(1.02, 0.5, "Angles", transform=axes[1][1].transAxes, va='center', rotation='vertical')
axes[2][1].text(1.02, 0.5, "Urey-Bradley", transform=axes[2][1].transAxes, va='center', rotation='vertical')
axes[3][1].text(1.02, 0.5, "Dihedrals", transform=axes[3][1].transAxes, va='center', rotation='vertical')
cbar_ax = fig.add_axes([0.84, 0.15, 0.05, 0.8])
fig.text(0.9,1, "Correlation\nCoefficient", transform=fig.transFigure, va='top', ha='center')
fig.colorbar(cax, cax=cbar_ax)
fig.savefig("correlations.png", dpi=300)
fig.savefig("correlations.pdf")