import os
import glob
from Molecule import Molecule
from atomsel import atomsel
import ast
import subprocess
from VMD import evaltcl
import measure
import numpy as np
from pyparsing import nestedExpr, originalTextFor
evaltcl("package require forcefieldtoolkit; ::ForceFieldToolKit::DihOpt::init")
# for d in glob.glob("*/"):
# 	if os.path.exists(d+"sysname.txt"):
# 		fin = open(d+"sysname.txt")
# 		flist = ast.literal_eval(fin.readlines()[0])
# 		fin.close()
# 		mol = Molecule()
# 		for f in flist:
# 			mol.load("../"+f)
# 		mol.save(d+"system.psf", filetype="psf")
def handlescan(filename, reverse=False):
	output = evaltcl("::ForceFieldToolKit::DihOpt::parseGlog %s" % filename)
	nestedBraces1 = nestedExpr('{', '}')
	#nestedBraces2 = originalTextFor(nestedExpr('{', '}'))
	energies = []
	coords = []
	for nb in nestedBraces1.searchString(output):
		#print nb
		energies.append(float(nb[0][2]))
		coordlist = []
		for coord in nb[0][3]:
			arr = np.empty(3, dtype=np.float)
			for j in range(3):
				arr[j] = float(coord[j])
			coordlist.append(arr)
		coorlist = np.vstack(coordlist)
		coords.append(coorlist)
	if reverse:
		coords = np.stack(coords[::-1])
		energies = energies[::-1]
	else:
		coords = np.stack(coords)
	return np.array(energies), coords
nummol = 0
for psf in glob.glob("../../chargegroups/psfs/*psf"):
	mol = Molecule()
	mol.load(psf)
	nummol += 1
for logfile in glob.glob("*/*log"):
	dname = os.path.dirname(logfile)
	energies, coords = handlescan(logfile)
	minframe = coords[0]
	natom = len(minframe)
	success = 0
	successlist = []
	for mid in range(nummol):
		mol = Molecule(id=mid)
		if natom == mol.numAtoms():
			mol.dupFrame()
			sel = atomsel("all", molid=mid)
			sel.frame = mol.numFrames() - 1
			for k, coordinate in enumerate(['x', 'y', 'z']):
				sel.set(coordinate, minframe[:,k])
			blist = sel.bonds
			#print blist
			fail = False
			for i, b in enumerate(blist):
				for j in b:
					if measure.bond(i, j, mid, mid)[0] > 1.6:
						fail = True
			if not fail:
				success += 1
				mol.save(dname+"/" + "system.psf", filetype="psf")
				successlist.append(mol.files())
	if success > 1:
		print "I have a major problem here!"
		print successlist
		print logfile
		exit()
exit()