import glob
import numpy as np
import cPickle as pickle
knownparameters, qmE, mmE, typesmap, geometries, btypes, atypes, dtypes, anglecycles = pickle.load( open( "everything.pkl", "rb" ) )

nummol = len(glob.glob("scanresults/*.js"))
print len(qmE)
print nummol
#exit()
solutionlist = []
#solutionlist.append("pythonlibrary/tightboundsnoforcefixdeltauppersolution.npy")
for prefix in ['tight', 'loose']:
	midfixes = ['', 'noforce', 'strongforce', 'reallystrongforce']
	if prefix == 'tight':
		for i in range(4):
			midfixes.append(midfixes[i] + "fixdelta")
		for i in range(4):
			midfixes.append(midfixes[i] + "fixdeltaupper")
		for i in range(4):
			midfixes.append(midfixes[i] + "fixdeltaupper2")
		# for i in range(4):
		# 	midfixes.append(midfixes[i] + "fixdeltaupper3.0")
	for midfix in midfixes:
		solutionlist.append("pythonlibrary/%sbounds%ssolution.npy" % (prefix, midfix))
print solutionlist

for f in solutionlist:#, 'optprogram/outputparametersmasked.npy']:
	print f
	data = np.load(f)
	fout = open("lignin%s.prm" % (f[14:-4]), "w")
	fout.write('''* Reoptimized parameters for lignins and lignin linkages
* Carbohydrate forcefield is required to make this not totally fail.
*
ATOMS
MASS  -1   CG2DC1 12.011000 ! 
MASS  -1   CG2DC2 12.011000 ! 
MASS  -1    CG2O2 12.011000 ! 
MASS  -1    CG2O3 12.011000 ! 
MASS  -1    CG2O4 12.011000 ! 
MASS  -1   CG2R61 12.011000 ! 
MASS  -1   CG2R62 12.011000 ! 
MASS  -1   CG2R63 12.011000 ! 
MASS  -1   CG2R67 12.011000 ! 
MASS  -1   CG2RC0 12.011000 ! 
MASS  -1    CG311 12.011000 ! 
MASS  -1    CG321 12.011000 ! 
MASS  -1    CG331 12.011000 ! 
MASS  -1   CG3C51 12.011000 ! 
MASS  -1   CG3C52 12.011000 ! 
MASS  -1   CG3RC1 12.011000 ! 
MASS  -1      CGO 12.011000 ! 
MASS  -1      CGO2 12.011000 ! 
MASS  -1     HGA1 1.008000 ! 
MASS  -1     HGA2 1.008000 ! 
MASS  -1     HGA3 1.008000 ! 
MASS  -1     HGA4 1.008000 ! 
MASS  -1     HGP1 1.008000 ! 
MASS  -1    HGR52 1.008000 ! 
MASS  -1    HGR61 1.008000 ! 
MASS  -1    HGR62 1.008000 ! 
MASS  -1    OG2D1 15.999400 ! 
MASS  -1    OG2D2 15.999400 ! 
MASS  -1    OG2D4 15.999400 ! 
MASS  -1    OG301 15.999400 ! 
MASS  -1    OG302 15.999400 ! 
MASS  -1    OG311 15.999400 ! 
MASS  -1   OG3C51 15.999400 ! 
MASS  -1   OG3R60 15.999400 ! 

BONDS
!
!V(bond) = Kb(b - b0)**2
!
!Kb: kcal/mole/A**2
!b0: A
!
!atom type Kb          b0
!

''')
	boffset = nummol
	for i, btype in enumerate(btypes):
		#print btype, btype.split("-")
		split = btype.split("-")
		if split[0][1] == 'C' and split[1][1] == 'C':
			continue
		key = "%-8s %-8s" % tuple(split)
		fout.write("%s %8.3f %8.4f\n" % (key, data[boffset+2*i+0], data[boffset+2*i+1]))
	fout.write('''
ANGLES
!
!V(angle) = Ktheta(Theta - Theta0)**2
!
!V(Urey-Bradley) = Kub(S - S0)**2
!
!Ktheta: kcal/mole/rad**2
!Theta0: degrees
!Kub: kcal/mole/A**2 (Urey-Bradley)
!S0: A
!
!atom types     Ktheta    Theta0   Kub     S0
!
''')
	aoffset = nummol + 2 * len(btypes)
	for i, atype in enumerate(atypes):
		asplit = atype.split("-")
		if asplit[0][1] == 'C' and asplit[1][1] == 'C' and asplit[2][1] == 'C':
			continue
		key = "%-8s %-8s %-8s" % tuple(asplit)
		fout.write("%s %8.3f %8.4f" % (key, data[aoffset+4*i+0], data[aoffset+4*i+1]))
		if data[aoffset+4*i+2] != 0:
			fout.write(" %8.2f %8.4f\n" % (data[aoffset+4*i+2], data[aoffset+4*i+3]))
		else:
			fout.write("\n")
	doffset = nummol + 2 * len(btypes) + 4 * len(atypes)
	fout.write('''
DIHEDRALS
!
!V(dihedral) = Kchi(1 + cos(n(chi) - delta))
!
!Kchi: kcal/mole
!n: multiplicity
!delta: degrees
!
!atom types             Kchi    n   delta
!
''')
	for i, dtype in enumerate(dtypes):
		dsplit = dtype.split("-")
		if dsplit[0][1] == 'C' and dsplit[1][1] == 'C' and dsplit[2][1] == 'C' and dsplit[3][1] == 'C':
			continue
		key = "%-8s %-8s %-8s %-8s" % tuple(dsplit)
		for j, n in enumerate([1, 2, 3, 4, 6]):
			if j == 0 and np.all(data[doffset+5*i:doffset+5*(i+1)] == 0):
				fout.write("%s 0.0 1 0.0\n" % (key))
			if data[doffset+5*i+j] != 0:
				if data[doffset+5*i+j] > 0:
					delta = 0
				else:
					delta = 180
				fout.write("%s %8.4f %d %8.2f\n" % (key, np.abs(data[doffset+5*i+j]), n, delta))
	fout.write('''
IMPROPERS
CG2DC1 OG2D2 OG2D2 CG2O3 96.0000  0     0.00 ! Acetate improper
CG2DC1 OG2D1 OG302 CG2O2 0 0 0 !This arrangement happens because the patch for gog does not remove the atoms in the acetate improper.

NONBONDED nbxmod  5 atom cdiel fshift vatom vdistance vfswitch -
cutnb 14.0 ctofnb 12.0 ctonnb 10.0 eps 1.0 e14fac 1.0 wmin 1.5
!
!V(Lennard-Jones) = Eps,i,j[(Rmin,i,j/ri,j)**12 - 2(Rmin,i,j/ri,j)**6]
!
!epsilon: kcal/mole, Eps,i,j = sqrt(eps,i * eps,j)
!Rmin/2: A, Rmin,i,j = Rmin/2,i + Rmin/2,j
!
!atom  ignored    epsilon      Rmin/2   ignored   eps,1-4       Rmin/2,1-4
!

CG2DC1   0.00 -0.068000 2.090000
CG2DC2   0.00 -0.068000 2.090000
CG2O2    0.00 -0.098000 1.700000
CG2O3    0.00 -0.070000 2.000000
CG2O4    0.00 -0.060000 1.800000
CG2R61   0.00 -0.070000 1.992400
CGO      0.00 -0.070000 1.992400
CGO2     0.00 -0.070000 1.992400
CG2R62   0.00 -0.090000 1.900000
CG2R63   0.00 -0.100000 1.900000
CG2R67   0.00 -0.070000 1.992400
CG2RC0   0.00 -0.099000 1.860000
CG311    0.00 -0.032000 2.000000 0.00 -0.010000 1.900000
CG321    0.00 -0.056000 2.010000 0.00 -0.010000 1.900000
CG331    0.00 -0.078000 2.050000 0.00 -0.010000 1.900000
CG3C51   0.00 -0.036000 2.010000 0.00 -0.010000 1.900000
CG3C52   0.00 -0.060000 2.020000 0.00 -0.010000 1.900000
CG3RC1   0.00 -0.032000 2.000000 0.00 -0.010000 1.900000
HGA1     0.00 -0.045000 1.340000
HGA2     0.00 -0.035000 1.340000
HGA3     0.00 -0.024000 1.340000
HGA4     0.00 -0.031000 1.250000
HGP1     0.00 -0.046000 0.224500
HGR52    0.00 -0.046000 0.900000
HGR61    0.00 -0.030000 1.358200
HGR62    0.00 -0.046000 1.100000
OG2D1    0.00 -0.120000 1.700000 0.00 -0.120000 1.400000
OG2D2    0.00 -0.120000 1.700000
OG2D4    0.00 -0.120000 1.700000
OG301    0.00 -0.100000 1.650000
OG302    0.00 -0.100000 1.650000
OG311    0.00 -0.192100 1.765000
OG3C51   0.00 -0.100000 1.650000
OG3R60   0.00 -0.100000 1.650000

END

''')
	fout.close()