import os
import numpy as np
for patch in ['dbbl', 'dbac', 'dbal', 'dbap', 'lcac', 'lcal', 'lcap', 'lch']:
	#for patch in ['LCH']:
	for resname in ['PHP', 'GUAI', 'SYR', 'CAT']:
		name = (resname+patch).lower()
		psfgenscript = '''topology top_all36_carb.rtf
topology top_lignin-1.top
segment LIGM {
	residue 1 %s
}
patch %s ligm:1
regenerate angles dihedrals
writepsf psfs/%s.psf
''' % (resname, patch, name)
		fout = open("psfs/%s.inp" % name, "w")
		fout.write(psfgenscript)
		fout.close()
		os.system("psfgen < psfs/%s.inp > psfs/%s.log" % (name, name))
# exit()
# for patch in ['dbap', 'lcap']:
# 	for resname in ['PHP', 'GUAI', 'SYR', 'CAT', 'PCA', 'FERU', 'FERUT']:
# 		if resname != "PCA" and resname != "FERU" and resname != "FERUT":
# 			patchtext = "patch %s ligm 1 setup" % patch
# 		else:
# 			patchtext = ""
# 		charmmscript = '''ioformat extended
# 	read rtf card name top_all36_carb.rtf
# 	read rtf card append name top_lignin-1.top
# 	read para card flex name ../../typing/lignins-cgo.prm

# 	read sequence %s 1
# 	bomlev -2
# 	generate ligm first none last none angle dihe setup
# 	%s
# 	write psf card name psfs/%s.psf
# 	stop
# 	''' % (resname.lower(), patchtext, resname.lower() + patch)
# 		fout = open("psfs/%s.inp" % (resname.lower() + patch), "w")
# 		fout.write(charmmscript)
# 		fout.close()
# 		os.system("charmm < psfs/%s.inp > psfs/%s.log" % (resname.lower() + patch, resname.lower() + patch))
# exit()

for resname in ['PHP', 'GUAI', 'SYR', 'CAT', "TRCN", "FERU", "FERUT", "PCA"]:
	charmmscript = '''ioformat extended
read rtf card name top_all36_carb.rtf
read rtf card append name top_lignin-1.top
read para card flex name ../../typing/lignins-cgo.prm
read sequence %s 1
bomlev -2
generate ligm first none last none angle dihe setup
write psf card name psfs/%s.psf
stop
''' % (resname.lower(), resname.lower())
	fout = open("psfs/%s.inp" % resname.lower(), "w")
	fout.write(charmmscript)
	fout.close()
	os.system("charmm < psfs/%s.inp > psfs/%s.log" % (resname.lower(), resname.lower()))

for linkage in ['BO4', '55', '4O5', 'AO4', 'B5', 'B1', 'BB', 'BDO', 'GOG', 'AOA', 'GOA', 'AOG']:
#for linkage in ['AOG']:
	#These linkages enforce some combinatorial constraints. For instance, BDO is only possible using C-lignin
	reslist1 = ['PHP'] # Shrinks the space considerably, since usually the parts that are different will be far away anyway.
	reslist2 = ['PHP', 'GUAI', 'SYR', 'CAT']
	print reslist1, reslist2
	if linkage == 'GOG':
		reslist1 = ['PCA']
	if linkage == 'BDO':
		reslist2 = ['CAT']
	if linkage in ['4O5', 'B5', '55']:
		reslist2 = ['PHP', 'GUAI', 'CAT']
		if linkage == '55':
			reslist1 = ['PHP', 'GUAI', 'CAT']
		elif linkage == '4O5':
			reslist1 = ['PHP', 'GUAI', 'CAT']
		elif linkage == 'B5':
			linkagelist = ["B5P", "B5G", "B5C"]
	if linkage == 'BB':
		reslist2 = ['PHP']
	if linkage in ['AOG', 'AOA']:
		if linkage == 'AOG':
			reslist1 = reslist2
		reslist2 = ['PHP']
	print reslist1, reslist2
	if linkage in ['GOA']:
		reslist1 = ['PCA']
		reslist2 = ['PHP']
	#This is H, G, S, and C-lignin.
	for resname in reslist1:
		for i, resname2 in enumerate(reslist2):
			name = resname[0] + linkage + resname2[0]
			if linkage == "B5":
				l = linkagelist[i]
			else:
				l = linkage
			charmmscript = '''ioformat extended
read rtf card name top_all36_carb.rtf
read rtf card append name top_lignin-1.top
read para card flex name ../../typing/lignins-cgo.prm

read sequ card
**
*
2
%s %s
bomlev -2
generate ligm first none last none angle dihe setup
patch %s ligm 1 ligm 2

write psf card name psfs/%s.psf
stop
''' % (resname.lower(), resname2.lower(), l.lower(), name.lower())
			fout = open("psfs/%s.inp" % name.lower(), "w")
			fout.write(charmmscript)
			fout.close()
			os.system("charmm < psfs/%s.inp > psfs/%s.log" % (name.lower(), name.lower()))
for linkage in ['DIFERA', 'DIFERB']:
	reslist1 = ['FERU']
	reslist2 = ['FERU']
	for resname in reslist1:
		for i, resname2 in enumerate(reslist2):
			name = "DIFERULATE" + linkage[-1]
			l = linkage
			psfgenscript = '''
topology top_all36_carb.rtf
topology top_lignin-1.top
segment LIGM {
	residue 1 %s
	residue 2 %s
}
patch %s ligm:1 ligm:2
regenerate angles dihedrals
writepsf psfs/%s.psf
''' % (resname, resname2, l, name.lower())
			charmmscript = '''ioformat extended
read rtf card name top_all36_carb.rtf
read rtf card append name top_lignin-1.top
read para card flex name /home/josh/toppar/par_all36_carb.prm
read para card flex append name ../../typing/lignins-cgo.prm

read sequ card
**
*
2
%s %s
bomlev -2
generate ligm first none last none angle dihe setup
patch %s ligm 1 ligm 2

write psf card name psfs/%s.psf
stop
''' % (resname.lower(), resname2.lower(), l.lower(), name.lower())
			fout = open("psfs/%s.inp" % name.lower(), "w")
			fout.write(psfgenscript)
			fout.close()
			#os.system("charmm < psfs/%s.inp > psfs/%s.log" % (name.lower(), name.lower()))
			os.system("psfgen < psfs/%s.inp > psfs/%s.log" % (name.lower(), name.lower()))
for linkage in ['FERUAB', 'LIHE', 'BET1', 'BET2', 'PGYS']:
	if linkage == 'FERUAB':
		reslist1 = ['FERU']
		reslist2 = ['AARB']
	elif linkage == 'PGYS':
		reslist1 = ['BARB']
		reslist2 = ['PHP', 'GUAI', 'SYR', 'CAT']
	else:
		reslist1 = ['BARB']
		reslist2 = ['PHP']
	for resname in reslist1:
		for i, resname2 in enumerate(reslist2):
			if linkage == 'PGYS':
				name = resname2[0] + linkage
			else:
				name = linkage
			l = linkage
			psfgenscript = '''
topology top_all36_carb.rtf
topology top_lignin-1.top
segment LIGM {
	residue 1 %s
	residue 2 %s
}
patch %s ligm:1 ligm:2
regenerate angles dihedrals
writepsf psfs/%s.psf
''' % (resname, resname2, l, name.lower())
			charmmscript = '''ioformat extended
read rtf card name top_all36_carb.rtf
read rtf card append name top_lignin-1.top
read para card flex name /home/josh/toppar/par_all36_carb.prm
read para card flex append name ../../typing/lignins-cgo.prm

read sequ card
**
*
2
%s %s

generate ligm first none last none angle dihe setup
bomlev -2
patch %s ligm 1 ligm 2

write psf card name psfs/%s.psf
stop
''' % (resname.lower(), resname2.lower(), l.lower(), name.lower())
			fout = open("psfs/%s.inp" % name.lower(), "w")
			fout.write(psfgenscript)
			fout.close()
			os.system("psfgen < psfs/%s.inp > psfs/%s.log" % (name.lower(), name.lower()))