#!/usr/bin/python
import subprocess
import numpy as np
#Alright, load in the topology and parameter file. Rename everything so that everything that is XG... becomes XLG... Possibly with a reduction in the number of charachters.
mappingdict = dict()
cgenffnames = [ "CG2DC1 ", " CG2DC2 ", "  CG2O2 ", "  CG2O3 ", "  CG2O4 ", " CG2R61 ", " CG2R62 ", " CG2R63 ", " CG2R67 ", " CG2RC0 ", "  CG311 ", "  CG321 ", "  CG331 ", " CG3C51 ", " CG3C52 ", " CG3RC1 ", "    CGO ", "    CGO2", "   HGA1 ", "   HGA2 ", "   HGA3 ", "   HGA4 ", "   HGP1 ", "  HGR52 ", "  HGR61 ", "  HGR62 ", "  OG2D1 ", "  OG2D2 ", "  OG2D4 ", "  OG301 ", "  OG302 ", "  OG311 ", " OG3C51 ", " OG3R60 "]
for i, n in enumerate(cgenffnames):
	name = n.strip()
	if name == "CGO":
		mname = "CLG2R6A"
	elif name == "CGO2":
		mname = "CLG2R6B"
	else:
		mname = name[0] + "L" + name[1:]
	mappingdict[name] = mname
print mappingdict
#exit()
fin = open("../optimization/chargegroups/top_lignin-1.top")
fout = open("top_lignin.top", "w")
for line in fin.readlines():
	s = line.split()
	if len(s) == 0:
		fout.write(line)
	elif (s[0] == 'MASS' or s[0] == 'ATOM') and s[2] in mappingdict:
		if s[0] == 'MASS':
			fout.write("MASS -1 %-7s %7.4f ! \n" % (mappingdict[s[2]], float(s[3])))
		elif s[0] == 'ATOM':
			if len(s) >=6:
				fout.write("ATOM %-4s %-7s %6.3f ! %6.3f %6.3f ! \n" % (s[1], mappingdict[s[2]], float(s[3]), float(s[5]), float(s[6])))
			else:
				fout.write("ATOM %-4s %-7s %6.3f ! \n" % (s[1], mappingdict[s[2]], float(s[3])))
	else:
		fout.write(line)
fout.close()
def isfloat(value):
	try:
		float(value)
		return True
	except ValueError:
		return False
import cPickle as pickle
#data = np.load("../optimization/bondedoptimization/pythonlibrary/lignintightboundsfixdeltaupper2solution.npy")
fin = open("../optimization/bondedoptimization/lignintightboundsfixdeltasolution.prm")
fout = open("par_lignin.prm", "w")
#knownparameters, qmE, mmE, typesmap, geometries, btypes, atypes, dtypes, anglecycles = pickle.load( open( "../optimization/bondedoptimization/everything.pkl", "rb" ) )
for line in fin.readlines():
	s = line.split()
	if len(s) == 0:
		fout.write(line)
	elif (s[0] == 'MASS') and s[2] in mappingdict:
		if s[0] == 'MASS':
			fout.write("MASS -1 %-7s %7.4f ! \n" % (mappingdict[s[2]], float(s[3])))
	else:
		foundone = False
		firstfloat = -1
		for i, el in enumerate(s):
			if el in mappingdict.keys():
				foundone = True
			if firstfloat == -1 and isfloat(el):
				firstfloat = i

		if foundone:
			l = ""
			for i in range(len(s)):
				if i < firstfloat:
					if s[i] in mappingdict.keys():
						l += "%-7s " % mappingdict[s[i]]
					else:
						l += "%-7s " % s[i]
				elif firstfloat == 3 and i == 3:
					l += "%7.3f " % (float(s[i]))
				else:
					l += "%s " % s[i]
			print l, s
			fout.write(l)
			fout.write("\n")
		else:
			fout.write(line)
fout.close()
