import glob
from Molecule import Molecule
import measure
from atomsel import *
import sys
psf = sys.argv[1]
print psf
pdblist = glob.glob("../*/*optimized.pdb")
print pdblist
#exit()
mol = Molecule()
mol.load(psf)
asel = atomsel("all")
element = asel.get("element")
print element
mass = asel.get("mass")
print mass
radius = asel.get("radius")
charge = asel.get("charge")
loadedlist = []
for pdb in pdblist:
	if (("pca" in psf) or ("feru" in psf)) and (("lcal" in pdb) or ("dbal" in pdb)):
		continue
	if (("pca" in pdb) or ("feru" in pdb)) and (("lcal" in psf) or ("dbal" in psf)):
		continue
	if (("lcac" in psf) or ("dbac" in psf)) and (("lcal" in pdb) or ("dbal" in pdb)):
		continue
	if (("lcac" in pdb) or ("dbac" in pdb)) and (("lcal" in psf) or ("dbal" in psf)):
		continue
	numbefore = mol.numFrames()
	mol.load(pdb)
	if mol.numFrames() > numbefore:
		loadedlist.append(pdb)
	# try:
	# 	mol.load(pdb)
	# except IOError:
	# 	print "I'm suppressing an I/O error here"
if mol.numFrames() == 0:
	print "I have a problem"
	print psf
	exit()
sel = atomsel("all")
bondlist = sel.bonds
#print bondlist
delframes = []
for f in range(mol.numFrames()):
	longbond = False
	for i, b in enumerate(bondlist):
		for j in b:
			if measure.bond(i, j, first=f, last=f)[0] > 1.65:
				longbond = True
	if longbond:
		delframes.append(f)
		
if len(delframes):
	for f in delframes[::-1]:
		mol.delFrame(first=f, last=f)
		del loadedlist[f]
if mol.numFrames() == 0:
	print "I have a problem, I deleted everything!"
	print psf
	exit()
jsname = "js/" + psf[5:-4] + ".js"
asel.set("mass", mass)
asel.set("radius", radius)
mol.save(jsname)
print loadedlist
#mol.delete()
exit()
