import glob
from Molecule import Molecule
import measure
from atomsel import *
import topology
import numpy as np
from VMD import evaltcl
import vmdnumpy as vnp
evaltcl("source structuremechanic.tcl")
jslist = glob.glob("js/*.js")
def writegaussian(name, molid):
	mol = Molecule(id=molid)
	sel = atomsel("all")
	q = int(np.round(np.sum(sel.get("charge"))))
	names = sel.get("name")
	R = vnp.timestep(molid, mol.numFrames()-1)
	fout = open(name, "w")
	fout.write('''
%nproc=24
%mem=3GB
''')
	fout.write('''
# MP2/6-31G*

title goes here

%d 1
''' % q)
	for i, n in enumerate(names):
		fout.write("%s %f %f %f\n" % (n[0], R[i][0], R[i][1], R[i][2]))
	fout.write("\n")
	fout.close()
for js in jslist:
	name = js[3:-3]
	mol = Molecule()
	mol.load(js)
	csel = atomsel("(name C1 C2 C3 C4 C5 C6) or (resname AARB BARB and name O4)")
	hsel = atomsel("(numbonds == 1)")
	idxlist = csel.get("index")
	idxlist2 = hsel.get("index")
	bondlist = topology.bonds()
	print bondlist
	for i, b in enumerate(bondlist):
		#If both are aromatic, this isn't a rotatable bond.
		print b
		if (b[0] in idxlist2) or (b[1] in idxlist2):
			print "Skip"
			continue
		elif (b[0] in idxlist) and (b[1] in idxlist):
			print "Skip"
			continue
		for j in range(360):
			mol.dupFrame()
			evaltcl("autorotatebond %d %d 1" % (b[0], b[1]))
			if j % 10 == 0:
			 	writegaussian("gaussian/%s-%d_%d.gau" % (name, i, j/10), int(mol))
		mol.save("trajs/%s-%d.dcd" % (name, i), first=mol.numFrames()-361)
		mol.delFrame(first=1)
		#exit()
	mol.delete()
exit()