from Molecule import Molecule
import numpy as np
import glob
from VMD import evaltcl

jsfiles = glob.glob("../js/*.js")
#prmfiles = ['../lignins-cgo.prm', '../lignintightboundssolution.prm', '../ligninlooseboundssolution.prm']
prmfiles = ['../../RMSDtest/parameters/lignins-cgo2.prm']
midfixes = ['noforce', '', 'strongforce', 'reallystrongforce']
prefixes = ['tightbounds', 'tightbounds', 'tightbounds', 'loosebounds']
postfix = ['','fixdelta', 'fixdeltaupper2', '']
for i in range(4):
	for j in range(4):
		prmfiles.append("../../RMSDtest/parameters/lignin%s%s%ssolution.prm" % (prefixes[j], midfixes[i], postfix[j]))
evaltcl("load /home/josh/CVS/miniNAMD/miniNAMD.so ; source /home/josh/CVS/miniNAMD/miniNAMD.tcl")
arraystack = []
for i, prmfile in enumerate(prmfiles):
	evaltcl("miniNAMD read %s" % prmfile)
	if i != 0:
		evaltcl("miniNAMD read ../par_all36_carb.prm")
	print prmfile
	#exit()
	arrlist = []
	for jsfile in jsfiles:
		mol = Molecule()
		mol.load(jsfile)
		for f in range(mol.numFrames()):
			arr = np.array(evaltcl("miniNAMDload [atomselect top \"all\" frame %d]; miniNAMD assign ; miniNAMD force" % f).replace("{", "").replace("}", "").split(), dtype=np.float)
			evaltcl("miniNAMD clear topology")
			arr.shape = (-1,3)
			arrlist.append(arr)
		mol.delete()
	evaltcl("miniNAMD clear parameters")
	arraystack.append(np.vstack(arrlist))
	#exit()
for i in range(len(prmfiles)):
	np.save("%d.npy" % i, np.linalg.norm(arraystack[i], axis=1))
exit()