import glob
import matplotlib
import numpy as np
from scipy.interpolate import interp1d
from matplotlib.ticker import MaxNLocator
import subprocess
import os
import time
matplotlib.use('Cairo')
matplotlib.rcParams['text.latex.preamble']=[r"\usepackage{amsmath}",r"\renewcommand{\seriesdefault}{\bfdefault}",
r"\usepackage{amsfonts}",r"\usepackage{textcomp}",r"\usepackage{gensymb}", r'\boldmath'] #Using \boldmath makes the axis label numbers bold as well! Looks good.
params = {'text.usetex' : True,
          'font.size' : 14,
          'font.family' : 'lmodern',
          'text.latex.unicode': True,
          'figure.figsize' : (5.6, 4.2), #8, 6 originally. Make it ~30% smaller so the text is ~30% bigger. (Multiply by .7)
          'figure.dpi' : 120
          }
matplotlib.rcParams.update(params)
import matplotlib.pyplot as plt
labels=['CGenFF', 'Optimized with all n', 'Optimized with CGenFF n', 'Reoptimized with some n removed']
loglist = sorted(glob.glob("logs/*_0.log"))
for log in loglist:
	if time.time() - os.path.getmtime(log) > 24*60*60:
		continue
	print log
	basename = log[5:-6]
	print basename
	m = 0
	datastuff = []
	for i in range(4):
		data = np.array(subprocess.check_output("grep ^ENERGY: %s" % ("logs/%s_%d.log" % (basename, i)), shell=True).split()[11::16], dtype=np.float)
		data -= np.amin(data)
		m = max(np.amax(data), m)
		datastuff.append(data)
	if m > 1e2:
		continue
	data = np.vstack(datastuff)
	print data
	fig, ax = plt.subplots(1,1)
	for i in range(4):
		ax.plot(data[i], label=labels[i], zorder=5-i)
	# if basename == "catdbbl-20":
	# 	qmdata = []
	# 	for i in range(36):
	# 		print i, subprocess.check_output("grep EUMP2 %s" % ("gaussian/%s_%d.log" % (basename, i)), shell=True).split()
	# 		qmdata.append(float(subprocess.check_output("grep EUMP2 %s" % ("gaussian/%s_%d.log" % (basename, i)), shell=True).split()[5].replace('D', 'E')))
	# 	qmdata.append(qmdata[0])
	# 	qmdata = np.array(qmdata)
	# 	qmdata -=np.amin(qmdata)
	# 	qmdata *= 627.509
	# 	print qmdata
	# 	ax.plot(np.arange(36)*10, qmdata, label="QM", zorder=6, color='k')
	if os.path.exists("scanresults/extra-%s.npy" % basename):
		ax.plot(np.arange(37)*10, np.load("scanresults/extra-%s.npy" % basename), label="QM")
	ax.set_ylabel("Energy (kcal/mol)")
	ax.set_xlim(0,360)
	ax.set_xlabel("Rotation (Degrees)")
	ax.legend(fontsize=10)
	fig.tight_layout()
	fig.savefig("plots/%s.png" % basename)
exit()