import subprocess
import glob
script = '''
usePluginIO yes
structure %s
temperature 0
paraTypeCharmm      on
parameters          %s
parameters par_all36_carb.prm
outputname test
# Force-Field Parameters
exclude             scaled1-4
1-4scaling          1.0
cutoff              12.
switching           on
switchdist          10.
pairlistdist        14
outputEnergies      1
coorfile open dcd %s
set ts 0
while { ![coorfile read] } {
	firsttimestep $ts
	run 0
	incr ts
}
coorfile close
'''
prmlist = ['lignins-cgo.prm', 'ligninlooseboundssolution.prm', 'lignintightboundssolution.prm', 'lignintightboundsremoval388solution.prm']
dcdlist = glob.glob("trajs/*dcd")
for dcd in dcdlist:
	name = dcd[6:-4]
	basename = name.split("-")[0]
	for i in range(4):
		fout = open("run.namd", "w")
		fout.write(script % ("js/%s.js" % basename, prmlist[i], dcd))
		fout.close()
		subprocess.call("gpunamd2 +p1 run.namd > logs/%s_%d.log" % (name, i), shell=True)