from Molecule import *
from atomsel import *
import numpy as np
import vmdnumpy as vnp
import os
import glob
optfileheader = '''-#- CacheSize=163840
-M- 16GB
-#- MaxDisk=128GB
-P- 16

# HF/6-31G* Opt=Tight SCF=Tight Geom=PrintInputOrient

 Title

%d 1
'''
def mymkdir(s):
	if not os.path.exists(s):
		os.makedirs(s)
def mysymlink(source, dest):
	#print source, dest
	if not os.path.exists(dest):
		os.symlink(source, dest)
reslist = ['PHP', 'GUAI', 'CAT']
#This is H, G, S, and C-lignin.
for resname in reslist:
	for resname2 in reslist:
		name = (resname[0] + "tri4o5" + resname2[0]).lower()
		namelist = glob.glob("%s*.pdb" % name)
		maxlength = max(len(s) for s in namelist)
		newnamelist = [s for s in namelist if len(s) == maxlength]
		for n in newnamelist:
			os.chdir("geomopt")
			mymkdir(n[:-4])
			os.chdir("..")
			m = Molecule()
			m.load(name + ".psf")
			m.load(n)
			sel = atomsel("all")
			names = sel.get("name")
			R = vnp.timestep(m, 0)
			#charge = int(np.sum(sel.get("charge")))
			charge = 0
			fout = open("geomopt/" + n[:-4] + "/" + n[:-4] + ".gau", "w")
			fout.write(optfileheader % charge)
			for i in range(len(sel)):
				fout.write("%s%d %.7f %.7f %.7f\n" % (names[i][0], i+1, R[i][0], R[i][1], R[i][2]))
			fout.write("\n")
			fout.close()
			m.delete()
exit()
