package require forcefieldtoolkit
proc ::ForceFieldToolKit::gui::consoleMessage { text } {
	puts $text
}
set halthere 0
foreach dir [glob -directory geomopt -types d -tails *] {
	::ForceFieldToolKit::GeomOpt::init
	set ::ForceFieldToolKit::GeomOpt::pdb $dir.pdb
	set ::ForceFieldToolKit::GeomOpt::logFile geomopt/$dir/$dir.log
	::ForceFieldToolKit::GeomOpt::loadLogFile
	set ::ForceFieldToolKit::GeomOpt::optPdb $dir-optimized.pdb
	::ForceFieldToolKit::GeomOpt::writeOptPDB
	set basename $dir
	
	if {! [file exists $basename.psf]} {
		set basename [format "%ss" $basename]
		set halthere 1
	}
	puts "$dir $basename"
	mol new $basename.psf
	mol addfile $dir-optimized.pdb
	topo guessatom element mass
	set sel [atomselect top "all"]
	#set q [expr {int([vecsum [$sel get charge]])}]
	set q 0
	$sel writepdb $dir-optimized.pdb
	::ForceFieldToolKit::GenZMatrix::init
	::ForceFieldToolKit::gui::gzmAutoDetect
	file mkdir watopt/$dir
	set ::ForceFieldToolKit::GenZMatrix::psfPath $basename.psf
	set ::ForceFieldToolKit::GenZMatrix::pdbPath $dir-optimized.pdb
	set ::ForceFieldToolKit::GenZMatrix::outFolderPath watopt/$dir
	set ::ForceFieldToolKit::GenZMatrix::basename $basename
	set ::ForceFieldToolKit::GenZMatrix::qmProc 1
	set ::ForceFieldToolKit::GenZMatrix::qmMem 1
	set ::ForceFieldToolKit::GenZMatrix::qmRoute "# HF/6-31G* Opt=(Z-matrix,MaxCycles=100) Geom=PrintInputOrient"
	set ::ForceFieldToolKit::GenZMatrix::qmCharge $q
	set ::ForceFieldToolKit::GenZMatrix::qmMult 1
	::ForceFieldToolKit::GenZMatrix::genZmatrix
	::ForceFieldToolKit::GenZMatrix::writeSPfiles
	mol delete top
	if {$halthere} {
		puts "I halted here"
		exit
	}
}

exit