from Molecule import Molecule
import molecule
import glob
from atomsel import atomsel
import numpy as np
import subprocess
from graphviz import Digraph
filelist = glob.glob("*mol2")
typemap = dict()
cgenffmap = dict()
for f in filelist:
	print f
	comboname = f[:-5]
	cgenfftypes = subprocess.check_output("cat %s.str | grep ATOM | awk '{print $3}'" % comboname, shell=True).split("\n")[:-1]
	cgenffcharges = np.array(subprocess.check_output("cat %s.str | grep ATOM | awk '{print $4}'" % comboname, shell=True).split("\n")[:-1], dtype=np.float)
	print cgenffcharges
	print cgenfftypes
	#exit()
	mol = Molecule()
	mol.load(comboname + ".psf")
	mol.load(comboname + ".pdb")
	allsel = atomsel("all")
	newtypes = allsel.get("type")
	allsel.set("charge", cgenffcharges)
	allsel.set("type", cgenfftypes)
	allsel.write("psf", comboname + "-cgenff.psf")
	
	for i in range(len(newtypes)):
		ctype = cgenfftypes[i]
		ntype = newtypes[i]
		if ctype in cgenffmap.keys():
			cgenffmap[ctype].add(ntype)
		else:
			cgenffmap[ctype] = set([ntype])
		if ntype in typemap.keys():
			typemap[ntype].add(ctype)
		else:
			typemap[ntype] = set([ctype])
print cgenffmap
print typemap
newtypegraph = Digraph(name="New Types")
for nt in sorted(typemap.keys(), reverse=True):
	newtypegraph.node(nt)
cgenfftypegraph = Digraph(name="CGenFF Types")
for ct in sorted(cgenffmap.keys(), reverse=True):
	cgenfftypegraph.node(ct)
g = Digraph('G', filename="relationships.gv",graph_attr={"rankdir": "LR"})
g.subgraph(cgenfftypegraph)
g.subgraph(newtypegraph)

for nt in typemap.keys():
	for ct in typemap[nt]:
		g.edge(ct, nt)
g.render(filename="relationships")
exit()