import glob
import pybel
import matplotlib
from rdkit import Chem
from rdkit.Chem import AllChem
from rdkit.Chem import Draw
import matplotlib.pyplot as plt
import numpy as np
mol2list = glob.glob("*.mol2")
from PIL import Image
from PIL import ImageFont
from PIL import ImageDraw
import Tkinter as tk
from rdkit.Chem.Draw.MolDrawing import MolDrawing, DrawingOptions
from Molecule import *
from atomsel import *
offsetlist = [(22,45), (0,50), (0,-50),(22,-45),(-22,45),(-22,0),(22,0),(-22,-45)]
for f in mol2list:
	print f
	if 'pybel' in f:
		continue
	basename = f[:-5]
	mol = Molecule()
	mol.load("%s.psf" % basename)
	charges = np.array(atomsel("all").get("charge"))
	types = atomsel("all").get("type")
	mol = pybel.readfile("pdb", "%s.pdb" % basename).next()
	mol.write(format="mol", filename="%s-pybel.mol" % basename, overwrite=True)
	m = Chem.MolFromMolFile("%s-pybel.mol" % basename, removeHs=False)
	# for i in range(m.GetNumAtoms()):
	# 	print i
	# 	print m.GetAtomWithIdx(i)
	# 	print m.GetAtomWithIdx(i).GetNumRadicalElectrons()
	# 	if m.GetAtomWithIdx(i).GetNumRadicalElectrons() > 0:
	# 		m.GetAtomWithIdx(i).SetIsAromatic(True)
	# 	print m.GetAtomWithIdx(i).GetNumRadicalElectrons()
	# 	#help(m.GetAtomWithIdx(i))
	# 	#exit()
	# exit()
	
	#plt.figure(figsize=(6,6))
	# help(m)
	#print Chem.SanitizeMol(m)
	AllChem.Compute2DCoords(m)
	#help(m.GetConformer())
	#exit()
	DrawingOptions.atomLabelFontSize=128
	DrawingOptions.bondLineWidth=15
	DrawingOptions.dotsPerAngstrom=360
	img, cnvs, drawer = Draw.MolToImage(m, size=(3000,3000), wedgeBonds=False, returnCanvas=True)
	print drawer.atomPs
	cnvs.flush()
	data = np.copy(np.asarray(img))
	dsum = np.sum(data, axis=2)
	print dsum
	#print data
	idxs = np.nonzero(dsum == 4*255)
	data[idxs] = np.array((255,255,255,0))
	#print data.shape
	#exit()
	#data[:200,:200] = np.array([0,0,0,255])
	img = Image.fromarray(data)
	print np.mean(np.mean(data, axis=0),axis=0)
	positions = drawer.atomPs[drawer.atomPs.keys()[0]]
	font = ImageFont.truetype("/usr/share/fonts/truetype/liberation/LiberationSans-Bold.ttf",24)
	draw = ImageDraw.Draw(img)
	for i in range(len(charges)):
		drawtext = "%.3f" % charges[i]
		#drawtext = types[i]
		w, h = draw.textsize(drawtext, font=font)
		print w, h
		for offset in offsetlist:
			xoffset = offset[0]
			if xoffset < 0:
				xoffset -= w
			elif xoffset == 0:
				xoffset -= w/2
			yoffset = offset[1]
			if yoffset < 0:
				yoffset += h
			elif yoffset == 0:
				yoffset += h/2
			datasubset = data[int(positions[i][1]-yoffset):int(positions[i][1]-yoffset+h),int(positions[i][0]+xoffset):int(positions[i][0]+xoffset+w)]
			#data[int(positions[i][1]-yoffset):int(positions[i][1]-yoffset+h),int(positions[i][0]+xoffset):int(positions[i][0]+xoffset+w)] = np.array([0,0,0,255])
			print datasubset.shape
			if np.linalg.norm(np.abs(np.mean(np.mean(datasubset, axis=0),axis=0) - np.array([255,255,255,0]))) < 5:
				break
		if charges[i] < 0:
			color=(255,136,136,255)
		else:
			color=(136,136,255,255)
		#color = (0,0,0,255)
		draw.text((positions[i][0]+xoffset, positions[i][1]-yoffset), drawtext,color,font=font)
	#Draw.MolToFile(m, "images/%s-rdkit.png" % basename, wedgeBonds=False)
	print basename
	#img = Image.fromarray(data)
	img.save("images/cgenffcharges/%s.png" % basename)
	#exit()
	# fig = Draw.MolToMPL(m, wedgeBonds=False)
	# ax = fig.get_axes()[0]
	# ax.set_xlim(0,2.5)
	# ax.set_ylim(0,2.5)
	# for child in ax.get_children():
	# 	print child
	# 	print child.properties()
	# 	if isinstance(child, matplotlib.text.Annotation):
	# 		#help(child)
	# 		child.set_backgroundcolor("none")
	# 		#exit()
	# 	#exit()
	# #help(ax)
	# print fig.get_size_inches()
	
	
exit()