from Molecule import Molecule
import molecule
import glob
from atomsel import atomsel
import numpy as np
import measure
import networkx as nx
psffiles = sorted(glob.glob("../monomers/*psf"))
psffiles += sorted(glob.glob("../dimers/*psf"))
psffiles += sorted(glob.glob("../trimers/*psf"))
print psffiles
signaturetracker = dict()
G = nx.Graph()
hydrograph = dict()
oxygraph = dict()
carbograph = dict()
print psffiles
#exit()
skiplist = ['trcn', 'feruarab', 'diferulateA', 'diferulateB']
for psf in psffiles:
	basename = psf.split("/")[-1][:-4]
	# if basename in skiplist:
	# 	print "Hi there!"
	#	continue
	optpdbfiles = sorted(glob.glob("%s*-optimized.pdb" % psf[:-4]))
	print psf, optpdbfiles
	if len(optpdbfiles):
		mol = Molecule()
		mol.load(psf)
		mol.rename(psf[:-4])
		for pdb in optpdbfiles:
			mol.load(pdb)
		allsel = atomsel("all")
		allsel.set("type", allsel.get("element"))
		#pucksel = atomsel("element C and pucker !=0 and numbonds == 3")
		#pucksel.set("type", "A")
		elements = np.array(allsel.get("type"))

		print elements
		bonds = allsel.bonds
		signatures = []
		for i in range(len(allsel)):
			sig = elements[i]
			others = []
			for j in bonds[i]:
				others.append(elements[j])
			sig += "".join(sorted(others))
			if sig == "HC":
				j = bonds[i][0]
				numh = 0
				print j
				print bonds[j]
				for k in bonds[j]:
					if elements[k] == 'H':
						numh += 1
				sig += str(numh) + str(len(bonds[j]))
			signatures.append(sig)
		print signatures
		for i, sig in enumerate(signatures):
			if sig in signaturetracker.keys():
				signaturetracker[sig].append((int(mol), i))
			else:
				signaturetracker[sig] = [(int(mol), i)]
			G.add_node((int(mol), i), bonds=len(sig))
			if sig[0] == 'C':
				carbograph[(int(mol), i)] = dict()
			elif sig[0] == 'O':
				oxygraph[(int(mol), i)] = dict()
			else:
				hydrograph[(int(mol), i)] = dict()
		print signaturetracker
		#exit()
print signaturetracker.keys()
#exit()
attrsuperdict = dict()
for key in signaturetracker.keys():
	print key
	atomlist = signaturetracker[key]
	bonddata = np.empty((len(atomlist),len(key)-1), dtype=[('el', 'a1'), ('l', 'f4')])
	for j, el in enumerate(atomlist):
		molid = el[0]
		atomid = el[1]
		sel = atomsel("all", molid=molid)
		elements = sel.get("type")
		bondidxs = sel.bonds[atomid]
		for i, idx in enumerate(bondidxs):
			bonddata[j][i]['el'] = elements[idx]
			bonddata[j][i]['l'] = np.mean(measure.bond(atomid, idx, molid=molid, molid2=molid, first=0, last=molecule.numframes(molid)-1))
			skey = key[0] + elements[idx]
			if key[0] == 'H':
				skey += key[2:]
			if skey in attrsuperdict:
				attrsuperdict[skey][(molid, atomid)] = bonddata[j][i]['l']
			else:
				attrsuperdict[skey] = dict()
				attrsuperdict[skey][(molid, atomid)] = bonddata[j][i]['l']
	# sortidxs = np.argsort(bonddata, axis=0, order=('el','l'))
	# bondedto = bonddata[0]['el']
	# for i in range(1, len(sortidxs)):
		# for j in range(len(bondedto)):
			# if bonddata[sortidxs[i,j],j]['l'] - bonddata[sortidxs[i-1,j],j]['l'] < 0.015:
				# G.add_edge(atomlist[sortidxs[i,j]], atomlist[sortidxs[i-1,j]], classifier = key[0]+bondedto[j], val=bonddata[sortidxs[i,j],j]['l'])
	n = len(key)-2
	if n > 0 and key[0] != 'H':
		angledata = np.empty((len(atomlist),n*(n+1)/2), dtype=[('el', 'a2'), ('a', 'f4')])
		for k, el in enumerate(atomlist):
			molid = el[0]
			atomid = el[1]
			sel = atomsel("all", molid=molid)
			elements = sel.get("type")
			bondidxs = sel.bonds[atomid]
			counter = 0
			for i, idx in enumerate(bondidxs):
				for j, idx2 in enumerate(bondidxs):
					if j > i:
						angledata[k][counter]['el'] = "".join(sorted([elements[idx], elements[idx2]]))
						angledata[k][counter]['a'] = np.mean(measure.angle(idx2, atomid, idx, molid=molid, molid2=molid, molid3=molid, first=0, last=molecule.numframes(molid)-1))
						print key[0]
						print angledata[k][counter]['el']
						skey = key[0] + angledata[k][counter]['el']
						if skey in attrsuperdict:
							attrsuperdict[skey][(molid, atomid)] = angledata[k][counter]['a']
						else:
							attrsuperdict[skey] = dict()
							attrsuperdict[skey][(molid, atomid)] = angledata[k][counter]['a']
						counter += 1
		# sortidxs = np.argsort(angledata, axis=0, order=('el','a'))
		# bondedto = angledata[0]['el']
		# for i in range(1, len(sortidxs)):
		# 	for j in range(len(bondedto)):
		# 		if angledata[sortidxs[i,j],j]['a'] - angledata[sortidxs[i-1,j],j]['a'] < 0.1:
		# 			G.add_edge(atomlist[sortidxs[i,j]], atomlist[sortidxs[i-1,j]], classifier = key[0]+bondedto[j], val=angledata[sortidxs[i,j],j]['a'])
	#result= np.diagonal(bonddata['l'][sortidxs[1:]] - bonddata['l'][sortidxs[:-1]], axis1=1, axis2=2)
	#jumppoints = np.nonzero(result>0.015)
	#for i in range(len(jumppoints[0])):
	#	jpidx = [jumppoints
	#print jumppoints
	# # 
	# # print np.diagonal(result)
	# # print result.shape
	# print bonddata['l'][sortidxs[1]]
	# print bonddata['l'][sortidxs[0]]
	# print bonddata['l'][sortidxs[1]] - bonddata['l'][sortidxs[0]]
	# atompair = atomlist[sortidxs[0][1]]
	# print atompair
	# print molecule.name(atompair[0])
print attrsuperdict
for skey in attrsuperdict.keys():
	nx.set_node_attributes(G, skey, attrsuperdict[skey])

for skey in attrsuperdict.keys():
	#print skey
	if skey[0] == 'C':
		store = carbograph
	elif skey[0] == 'O':
		store = oxygraph
	else:
		store = hydrograph
	attrdict = nx.get_node_attributes(G, skey)
	vals = np.array(attrdict.values())
	keys = attrdict.keys()
	asort = np.argsort(vals)
	if len(skey) == 2:
		cutoff = .05
	else:
		cutoff = 2
	H =  G.subgraph(attrsuperdict[skey].keys())
	for i in range(1,len(asort)):
		if vals[asort[i]] - vals[asort[i-1]] < cutoff:
			H.add_edge(keys[asort[i]], keys[asort[i-1]], classifier=skey)
	subH = list(nx.connected_component_subgraphs(H))
	glens = []
	for i, h in enumerate(subH):
		glens.append(len(h))
		for node in h.nodes():
			store[node][skey] = i
	print skey, len(subH), glens
	if len(asort)>1:
		print np.amax(vals[asort[1:]] - vals[asort[:-1]])
#print carbograph
typeprefix = ['C', 'O', 'H']
for j, graph in enumerate([carbograph, oxygraph, hydrograph]):
	togetherdict = dict()
	for k in graph.keys():
		val = frozenset(graph[k].items())
		if val in togetherdict.keys():
			togetherdict[val].append(k)
		else:
			togetherdict[val] = [k]
	print typeprefix[j]
	print len(togetherdict.keys())
	print togetherdict.keys()
	np.argsort(togetherdict.values())
	keylist = togetherdict.keys()
	for i, k in enumerate(sorted(togetherdict, key=lambda k: len(togetherdict[k]), reverse=True)):
		print k, togetherdict[k]
		typename = typeprefix[j] + "LG" + str(i+1)
		for pair in togetherdict[k]:
			print pair
			sel = atomsel("index %d" % pair[1], molid=pair[0])
			sel.set("type", typename)

	#Figure out if I can safely merge any of these. I think I'm going to argue against merging. CGenFF certainly doesn't do any merging.
	# while True:
	# 	maxmergeable = 0
	# 	mergepair = []
	# 	for x in range(len(keylist)-1):
	# 		xk = keylist[x]
	# 		for y in range(x+1, len(keylist)):
	# 			yk = keylist[y]
	# 			mergeable = 0
	# 			for xel in xk:
	# 				for yel in yk:
	# 					if xel[0] == yel[0]:
	# 						if xel[1] == yel[1] and mergeable >=0:
	# 							mergeable += 1
	# 						elif xel[1] != yel[1]:
	# 							mergeable = -1
	# 					if mergeable > maxmergeable:
	# 						maxmergeable = mergeable
	# 						mergepair = [x, y]
	# 	if maxmergeable >= 0:
	# 		#Merge the two lists together.
	# 		print keylist[mergepair[0]], keylist[mergepair[1]]
	# 		newkey = keylist[mergepair[0]].union(keylist[mergepair[1]])
	# 		print newkey
	# 		exit()
	# 	else:
	# 		break

for mid in molecule.listall():
	shortname = molecule.name(mid).split("/")[-1]
	molecule.write(mid, "psf", shortname + ".psf")
	molecule.write(mid, "pdb", shortname + ".pdb", beg=molecule.numframes(mid)-1, end=molecule.numframes(mid)-1)
	for i in range(molecule.numframes(mid)):
		molecule.write(mid, "pdb", shortname + "-" + str(i) + ".pdb", beg=i, end=i)
	allsel = atomsel("all", molid=mid)
	types = allsel.get("type")
	newtypes = []
	for t in types:
		newtypes.append(t[0])
	allsel.set("type", newtypes)
	molecule.write(mid, "mol2", shortname + ".mol2")
exit()
#exit()
# classifierattribute = nx.get_edge_attributes(G, "classifier")
# classset = set(classifierattribute.values())
# for s in classset:
# 	H =  G.subgraph(attrsuperdict[s].keys())
# 	H = nx.Graph(((source, target, attr) for source, target, attr in H.edges_iter(data=True) if attr['classifier'] == s))
# 	#print s
# 	vals = np.array(nx.get_node_attributes(H, s).values())
# 	#print vals
# 	asort = np.argsort(vals)
# 	# #print vals, asort
# 	# edges = H.edges()
# 	# if len(s) == 3:
# 	# 	cutoff = .015
# 	# else:
# 	# 	cutoff = 0.1
# 	# for i in range(1,len(asort)):
# 	# 	#print edges[asort[i]]
# 	# 	if vals[asort[i]] - vals[asort[i-1]] < cutoff:
# 	# 		H.add_edge(edges[asort[i]][0], edges[asort[i-1]][0], classifier=s)
# 	# #exit()
# 	subH = list(nx.connected_component_subgraphs(H))
# 	glens = []
# 	for h in subH:
# 		glens.append(len(h))
# 	print s, len(subH), glens
# 	if len(asort)>1:
# 		print np.amax(vals[asort[1:]] - vals[asort[:-1]])
# subGs = list(nx.connected_component_subgraphs(G))
# print len(subGs)
# print len(signaturetracker.keys())
# exit()
exit()