from Molecule import Molecule
import molecule
import glob
from atomsel import atomsel
import numpy as np
import subprocess
import topology
from VMD import evaltcl
import measure

#There are some sugars that I need to give parameters for again. No biggie.
def reassign(atomtypes):
	for i in range(len(atomtypes)):
		atomtype = atomtypes[i]
		print atomtype
		if len(atomtype):
			if atomtype[1] == 'C':
				atomtype = atomtype[0] + 'G' + atomtype[2:]
			if atomtype == 'CG3152' or atomtype == 'CG3151' or atomtype == 'CG3153':
				atomtype = 'CG3C51'
			atomtypes[i] = atomtype
	return atomtypes

masses = dict()
prunelist = glob.glob("*psf")
filelist=[]
for f in prunelist:
	# if f.find("cgenff") == -1: #This controls if we write cgenff atomtypes or not.
	# 	filelist.append(f)
	# 	filetail = -4
	#This is the one for CGenFF atomtypes.
	if f.find("cgenff") != -1:
		filelist.append(f)
		filetail = -11
knownparameters = dict()
knownparameters['bonds'] = dict()
knownparameters['angles'] = dict()
knownparameters['dihedrals'] = dict()
knownparameters['nonbonded'] = dict()
newparameters = dict()
newparameters['bonds'] = dict()
newparameters['angles'] = dict()
newparameters['dihedrals'] = dict()
newparameters['nonbonded'] = dict()
datastore = dict()
datastore['bonds'] = dict()
datastore['angles'] = dict()
datastore['dihedrals'] = dict()
datastore['nonbonded'] = dict()
def readparameters(filename):
	#print filename
	fin = open(filename)
	lines = fin.readlines()
	fin.close()
	readstate = 0
	for l in lines:
		s = l.strip()
		if s.find("!") != -1:
			s = s[:s.find("!")]
		if len(s):
			splt = s.split()
			if splt[0] == "BONDS":
				readstate = 1
				skiplines = 1
			elif splt[0] == "ANGLES":
				readstate = 2
				skiplines = 1
			elif splt[0] == "DIHEDRALS":
				readstate = 3
				skiplines = 1
			elif splt[0] == "IMPROPERS" or splt[0] == "IMPROPER":
				readstate = 0
			elif splt[0] == "NONBONDED":
				readstate = 4
				skiplines = 2
			elif splt[0] == "END":
				readstate = 0
			elif splt[0] == "HBOND":
				readstate = 0
			if readstate != 0:
				if skiplines:
					skiplines -= 1
				else:
					#print splt
					if readstate == 1:
						bondkey = tuple(sorted(splt[:2]))
						bondprm = np.array(splt[2:], dtype=np.float)
						#print bondkey, bondprm
						knownparameters['bonds'][bondkey] = bondprm
					elif readstate == 2:
						q = splt[:3]
						if splt[0] > splt[2]: 
							q.reverse()
						anglekey = tuple(q)
						# if filename[:5] == "pao4p":
						# 	print anglekey
						anglprm = np.array(splt[3:], dtype=np.float)
						knownparameters['angles'][anglekey] = anglprm
					elif readstate == 3:
						q = splt[:4]
						#print q
						if splt[0] > splt[3]: 
							q.reverse()
						elif splt[0] == splt[3] and splt[1] > splt[2]:
							q.reverse()
						anglekey = tuple(q)
						#print anglekey
						anglprm = tuple(np.array(splt[4:], dtype=np.float))
						if anglekey in knownparameters['dihedrals']:
							knownparameters['dihedrals'][anglekey].add(anglprm)
							#print len(knownparameters['dihedrals'][anglekey])
						else:
							knownparameters['dihedrals'][anglekey] = set([anglprm])
					else:
						knownparameters['nonbonded'][splt[0]] = np.array(splt[1:], dtype=np.float)

readparameters("/home/josh/toppar/par_all36_cgenff.prm")
readparameters("/home/josh/toppar/par_all36_carb.prm")
for f in filelist:
	print f
	readparameters("%s.str" % f[:filetail])
#exit()
typemap = dict()
for f in filelist:
	print f
	mol = Molecule()
	mol.load(f)
	mol.load(f[:filetail]+ ".pdb")
	#For reasons that are very opaque to me, the psfs I'm loading don't have all the angle and dihedral info..
	evaltcl("package require topotools; topo guessangles; topo guessdihedrals")
	#mol.load(f[:-3] + "pdb")
	cgenfftypes = reassign(np.array(subprocess.check_output("cat %s.str | grep ATOM | awk '{print $3}'" % f[:filetail], shell=True).split("\n")))
	newtypes = np.array(atomsel("all").get("type"))
	print newtypes
	#exit()
	mass = np.array(atomsel("all").get("mass"))
	for i in range(len(newtypes)):
		ctype = cgenfftypes[i]
		ntype = newtypes[i]
		if ntype in typemap.keys():
			if ctype in typemap[ntype].keys():
				typemap[ntype][ctype] += 1
			else:
				typemap[ntype][ctype] = 1
		else:
			typemap[ntype] = dict()
			typemap[ntype][ctype] = 1
		masses[ntype] = mass[i]
	for b in topology.bonds():
		barr = np.array(b)
		ckey = tuple(sorted(cgenfftypes[barr]))
		nkey = tuple(sorted(newtypes[barr]))
		#if nkey in newparameters['bonds'].keys():
		#	print newparameters['bonds'][nkey] - knownparameters['bonds'][ckey]
		if nkey in datastore['bonds'].keys():
			datastore['bonds'][nkey].append(measure.bond(barr[0], barr[1])[0])
		else:
			datastore['bonds'][nkey] = [measure.bond(barr[0], barr[1])[0]]
		print nkey, ckey
		print cgenfftypes
		newparameters['bonds'][nkey] = knownparameters['bonds'][ckey]
	for a in topology.angles():
		arr = np.array(a)
		ctypes = cgenfftypes[arr]
		if ctypes[0] > ctypes[2]:
			ctypes = ctypes[::-1]
		ntypes = newtypes[arr]
		if ntypes[0] > ntypes[2]:
			ntypes = ntypes[::-1]
		nkey = tuple(ntypes)
		ckey = tuple(ctypes)
		newparameters['angles'][nkey] = knownparameters['angles'][ckey]
		if nkey in datastore['angles'].keys():
			datastore['angles'][nkey].append(measure.angle(arr[0], arr[1], arr[2])[0])
		else:
			datastore['angles'][nkey] = [measure.angle(arr[0], arr[1], arr[2])[0]]
	for d in topology.dihedrals():
		arr = np.array(d)
		ctypes = cgenfftypes[arr]
		if ctypes[0] > ctypes[3]:
			ctypes = ctypes[::-1]
		elif ctypes[0] == ctypes[3] and ctypes[1] > ctypes[2]:
			ctypes = ctypes[::-1]
		ntypes = newtypes[arr]
		if ntypes[0] > ntypes[3]:
			ntypes = ntypes[::-1]
		elif ntypes[0] == ntypes[3] and ntypes[1] > ntypes[2]:
			ntypes = ntypes[::-1]
		nkey = tuple(ntypes)
		ckey = tuple(ctypes)
		newparameters['dihedrals'][nkey] = knownparameters['dihedrals'][ckey]
		if nkey in datastore['dihedrals'].keys():
			datastore['dihedrals'][nkey].append(measure.dihedral(arr[0], arr[1], arr[2], arr[3])[0])
		else:
			datastore['dihedrals'][nkey] = [measure.dihedral(arr[0], arr[1], arr[2], arr[3])[0]]

#print typemap
for t in typemap.keys():
	mix = typemap[t]
	storage = np.zeros((len(mix.keys()),6), dtype=np.float)
	weights = np.ones(len(mix.keys()),dtype=np.int)
	for i, k in enumerate(mix.keys()):
		weights[i] = mix[k]
		prm = knownparameters['nonbonded'][k]
		storage[i][:len(prm)] = prm
		if len(prm) < 6:
			storage[i][len(prm):] = prm
	#print np.sum((storage.T * weights), axis=1) / np.sum(weights)
	#print mix
	#if len(weights) > 1:
	#	exit()
	newparameters['nonbonded'][t] = np.sum((storage.T * weights), axis=1) / np.sum(weights)
#print newparameters

fout = open("lignins-cgenff.prm", "w")
fout.write('''* CGenFF-derived parameters for lignins and lignin linkages
*
''')
fout.write("ATOMS\n")
#Mass lines.
for j, k in enumerate(sorted(newparameters['nonbonded'].keys())):
	fout.write("MASS %-7d %-8s %.5f\n" % (700+j, k, masses[k]))
#Bonds
fout.write('''
BONDS
!
!V(bond) = Kb(b - b0)**2
!
!Kb: kcal/mole/A**2
!b0: A
!
!atom type Kb          b0
!

''')
for k in sorted(newparameters['bonds'].keys()):
	bondprm = newparameters['bonds'][k]
	fout.write("%-8s %-8s %.3f %.4f ! %.4f %.4f\n" % (k[0], k[1], bondprm[0], bondprm[1], np.mean(datastore['bonds'][k]), np.std(datastore['bonds'][k])))
#Angles
fout.write('''
ANGLES
!
!V(angle) = Ktheta(Theta - Theta0)**2
!
!V(Urey-Bradley) = Kub(S - S0)**2
!
!Ktheta: kcal/mole/rad**2
!Theta0: degrees
!Kub: kcal/mole/A**2 (Urey-Bradley)
!S0: A
!
!atom types     Ktheta    Theta0   Kub     S0
!

''')
for k in sorted(newparameters['angles'].keys()):
	angleprm = newparameters['angles'][k]
	if len(angleprm) == 2:
		fout.write("%-8s %-8s %-8s %.3f %.4f ! %.4f %.4f\n" % (k[0], k[1], k[2], angleprm[0], angleprm[1], np.mean(datastore['angles'][k]), np.std(datastore['angles'][k])))
	else:
		fout.write("%-8s %-8s %-8s %.3f %.4f %.2f %.5f ! %.4f %.4f\n" % (k[0], k[1], k[2], angleprm[0], angleprm[1], angleprm[2], angleprm[3], np.mean(datastore['angles'][k]), np.std(datastore['angles'][k])))
#fout.close()
#exit()
#Dihedrals
fout.write('''
DIHEDRALS
!
!V(dihedral) = Kchi(1 + cos(n(chi) - delta))
!
!Kchi: kcal/mole
!n: multiplicity
!delta: degrees
!
!atom types             Kchi    n   delta
!


''')
for k in sorted(newparameters['dihedrals'].keys()):
	for el in newparameters['dihedrals'][k]:
		fout.write("%-8s %-8s %-8s %-8s %.4f %d %.2f\n" % (k[0], k[1], k[2], k[3], el[0], el[1], el[2]))
fout.write('''
IMPROPERS
CG2DC1 OG2D2 OG2D2 CG2O3 96.0000  0     0.00 ! Acetate improper
CG2DC1 OG2D1 OG302 CG2O2 0 0 0 !This arrangement happens because the patch for gog does not remove the atoms in the acetate improper.
''')
fout.write('''
NONBONDED nbxmod  5 atom cdiel fshift vatom vdistance vfswitch -
cutnb 14.0 ctofnb 12.0 ctonnb 10.0 eps 1.0 e14fac 1.0 wmin 1.5
!
!V(Lennard-Jones) = Eps,i,j[(Rmin,i,j/ri,j)**12 - 2(Rmin,i,j/ri,j)**6]
!
!epsilon: kcal/mole, Eps,i,j = sqrt(eps,i * eps,j)
!Rmin/2: A, Rmin,i,j = Rmin/2,i + Rmin/2,j
!
!atom  ignored    epsilon      Rmin/2   ignored   eps,1-4       Rmin/2,1-4
!

''')
for k in sorted(newparameters['nonbonded'].keys()):
	prms = newparameters['nonbonded'][k]
	fout.write("%-8s 0.00 %.6f %.6f" % (k, prms[1], prms[2]))
	if prms[4] != prms[1] or prms[2] != prms[5]:
		fout.write(" 0.00 %.6f %.6f\n" % (prms[4], prms[5]))
	else:
		fout.write("\n")
fout.write("\nEND\n\n")
fout.close()

exit()